---------------------------------------------------------
--Instance Module Template for BossTactics
--refer www.bosstactics.net for howto create modules!
---------------------------------------------------------

--available buttontypes:
--f: rangedDPS, h: healer, t: tank, n:melee, b,x,y,z: boss
--empty captions are not "" please use " " or you will get exceptions!

--local variable definition dont change!!
local BT_main = LibStub("AceAddon-3.0"):GetAddon( "BossTactics" )

BT_Ulduar = LibStub("AceAddon-3.0"):NewAddon("BT_Ulduar","AceConsole-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("BT_Ulduar")

--feel free to use localisations from the framework
local L_main = LibStub("AceLocale-3.0"):GetLocale("BossTactics")

local BabbleBoss = LibStub("LibBabble-Boss-3.0"):GetLookupTable();
local BabbleZone = LibStub("LibBabble-Zone-3.0"):GetLookupTable();
local BabbleClass = LibStub("LibBabble-Class-3.0"):GetLookupTable();

--db profile defaults add your boss-data here
local defaults = {
    profile = {
        ["instance"] = BabbleZone["Ulduar"], --instance name
		["version"] = 9, --change this to a higher value for update handling (explained in a tutorial)
		["initial"] = true, --never change this flag!
		["id"] = "BT_Ulduar", --very important this must be the same name as your module case sensitive!
		["info"] = L["info"], --a short text you can add to the info frame, optional
		["patchlevel"] = "3.2.0", --put in the patchlevel to which this guide belongs to
		["bosses"] = {
			["mode10"] = {
		    -- first boss
                [1] = {
                    ["name"] = BabbleBoss["Flame Leviathan"],
                    ["ratext"] = L["ra-Flame Leviathan"], --lines seperated by \n
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Flame Leviathan"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Flame Leviathan"],} }, --optional
                    ["actionBtn1"] = {
                    	["text"] = L["VehicleInfo"],
                    	["action"] = function () BT_Ulduar:VehicleInfo() end,
                    },
                    ["actionBtn2"] = {
                    	["text"] = L["VehicleCheck"],
                    	["action"] = function () BT_main:BT_SendDataMessage("{UlduarIlvl}") end,
                    	["raidleadOnly"] = true,
                    },
                    ["actionBtn3"] = {
                    	["text"] = L["Assign Vehicle"],
                    	["action"] = function () BT_Ulduar:ShowLeviathanTasks() end,
                    	["raidleadOnly"] = true,
                    },
                    ["imgdata"] = {
                        --first image
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_leviathan",
                            ["btnId"] = 7, --start id of new buttons set this to the number of buttons on your current image +1
                            ["buttons"] = {
								{
                                    ["y"] = -243.420952529253,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 309.6052750956907,
                                }, -- [1]
                                {
                                    ["y"] = -150.6578027838747,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 299.3421036340897,
                                }, -- [2]
                                {
                                    ["y"] = -150.6578027838747,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 136.1184434086302,
                                }, -- [3]
                                {
                                    ["y"] = -119.0789579724299,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 222.5657577530541,
                                }, -- [4]
                                {
                                    ["y"] = -201.9735428471762,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 169.6710637247101,
                                }, -- [5]
                                {
                                    ["y"] = -206.9078252824922,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 345.1314755085661,
                                }, -- [6]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L["Chopper"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L["Demolisher"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L["Siege Engine"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Flame Leviathan"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                --second boss
                [2] = {
                    ["name"] = BabbleBoss["Ignis the Furnace Master"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Ignis the Furnace Master"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Ignis the Furnace Master"],} }, --optional
                    ["ratext"] = L["ra-Ignis the Furnace Master"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_ignis",
                            ["btnId"] = 10,
                            ["buttons"] = {
                            	{
						            ["y"] = -274.0773283233468,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 258.7070368975271,
                                }, -- [1]
                                {
                                    ["y"] = -371.5023702382173,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 214.6909214003661,
                                }, -- [2]
                                {
                                    ["y"] = -370.5183203462193,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 255.4862384340929,
                                }, -- [3]
                                {
                                    ["y"] = -216.9999874183343,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 272.9317832627436,
                                }, -- [4]
                                {
                                    ["y"] = -246.5227797384012,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 274.6317380882377,
                                }, -- [5]
                                {
                                    ["y"] = -242.5862742742681,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 167.6340723035294,
                                }, -- [6]
                                {
                                    ["y"] = -273.0931344802236,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 294.1342365329259,
                                }, -- [7]
                                {
                                    ["y"] = -372.486384142434,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 305.674996174541,
                                }, -- [8]
                                {
                                    ["y"] = -373.4703620588694,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 349.511748569679,
                                }, -- [9]
                          	},
                          	["legend"] = { --optional, puts buttons to the legend
				                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Ignis the Furnace Master"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                    [5] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                },
                            },
                        },
                    },
                },
                [3] = {
                    ["name"] = BabbleBoss["Razorscale"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Razorscale"],} },
                    ["ratext"] = L["ra-Razorscale"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_razorscale",
                            ["btnId"] = 11,
                            ["buttons"] = {
                            	{
                                    ["y"] = -212.8289173069899,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 378.6843303140532,
                                }, -- [1]
                                {
                                    ["y"] = -265.1317209896644,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 192.5656714988125,
                                }, -- [2]
                                {
                                    ["y"] = -241.4474310548092,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 161.184188605204,
                                }, -- [3]
                                {
                                    ["y"] = -222.6974821776219,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 404.5394841004045,
                                }, -- [4]
                                {
                                    ["y"] = -195.0657780189843,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 150.9210953067388,
                                }, -- [5]
                                {
                                    ["y"] = -280.9209479875473,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 338.8157378115315,
                                }, -- [6]
                                {
                                    ["y"] = -226.6446423712131,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 113.6184031439289,
                                }, -- [7]
                                {
                                    ["y"] = -247.368503538523,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 355.395037785846,
                                }, -- [8]
                                {
                                    ["y"] = -189.1446078313508,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 186.2500119649136,
                                }, -- [9]
                                {
                                    ["y"] = -248.3552935869208,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 317.8947687565764,
                                }, -- [10]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 1"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                },
                            },
                        },
                        [2] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_razorscale",
                            ["btnId"] = 12,
                            ["buttons"] = {
                            	{
                                    ["y"] = -251.3157418952499,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 261.0526605044499,
                                }, -- [1]
                                {
                                    ["y"] = -187.1710081937713,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 86.7763420644762,
                                }, -- [2]
                                {
                                    ["y"] = -203.947396514947,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 135.5262697215935,
                                }, -- [3]
                                {
                                    ["y"] = -239.4735578462545,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 303.6841244488412,
                                }, -- [4]
                                {
                                    ["y"] = -233.5527784742999,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 126.4473186189704,
                                }, -- [5]
                                {
                                    ["y"] = -196.0526853120858,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 450.9210589730936,
                                }, -- [6]
                                {
                                    ["y"] = -182.2367257584553,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 159.9999291646582,
                                }, -- [7]
                                {
                                    ["y"] = -220.7237066729869,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 426.4472822853252,
                                }, -- [8]
                                {
                                    ["y"] = -253.289497859101,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 421.7103617678455,
                                }, -- [9]
                                {
                                    ["y"] = -278.9474265131036,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 397.8290225676972,
                                }, -- [10]
                                {
                                    ["y"] = -226.6447986974846,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 228.6842312361721,
                                }, -- [11]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 2"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Razorscale"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [3] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_razorscale",
                            ["btnId"] = 14,
                            ["buttons"] = {
                            	{
                                    ["y"] = -261.1840722764746,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 266.9737720697316,
                                }, -- [1]
                                {
                                    ["y"] = -189.1446078313508,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 233.2236335095439,
                                }, -- [2]
                                {
                                    ["y"] = -213.8158050593074,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 177.7631563861915,
                                }, -- [3]
                                {
                                    ["y"] = -222.6973258513503,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 252.3684820894594,
                                }, -- [4]
                                {
                                    ["y"] = -286.8419813896932,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 279.2105040873443,
                                }, -- [5]
                                {
                                    ["y"] = -246.3815376230697,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 356.7763367212931,
                                }, -- [6]
                                {
                                    ["y"] = -194.0790661337223,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 350.8552056152275,
                                }, -- [7]
                                {
                                    ["y"] = -257.2369120828835,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 302.8947549406315,
                                }, -- [8]
                                {
                                    ["y"] = -232.5657343957108,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 287.8947215839027,
                                }, -- [9]
                                {
                                    ["y"] = -184.2105012630903,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 293.4210897727277,
                                }, -- [10]
                                {
                                    ["y"] = -167.4340347787789,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 211.3157571614874,
                                }, -- [11]
                                {
                                    ["y"] = -161.5130795397687,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 250.7895085836329,
                                }, -- [12]
                                {
                                    ["y"] = -190.1314955836683,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 182.6973801991557,
                                }, -- [13]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 3"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = L["Razorscale cite"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [4] = {
                    ["name"] = BabbleBoss["XT-002 Deconstructor"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-XT-002 Deconstructor"],} },
                    ["ratext"] = L["ra-XT-002 Deconstructor"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_xt",
                            ["btnId"] = 11,
                            ["buttons"] = {
                            	{
                                    ["y"] = -168.0306216657268,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 226.8989664829345,
                                }, -- [1]
                                {
                                    ["y"] = -196.317719533022,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 342.9178153645474,
                                }, -- [2]
                                {
                                    ["y"] = -219.1650123416301,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 257.7551240942343,
                                }, -- [3]
                                {
                                    ["y"] = -137.5674056415486,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 252.7087554546617,
                                }, -- [4]
                                {
                                    ["y"] = -152.7991531062903,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 250.9262806466358,
                                }, -- [5]
                                {
                                    ["y"] = -156.0630289439463,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 362.5933790495304,
                                }, -- [6]
                                {
                                    ["y"] = -159.3269767571649,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 282.3849636864309,
                                }, -- [7]
                                {
                                    ["y"] = -219.1650123416301,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 241.7370885927098,
                                }, -- [8]
                                {
                                    ["y"] = -232.2207496128326,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 245.7877472991416,
                                }, -- [9]
                                {
                                    ["y"] = -181.0861969919135,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 155.7875244841675,
                                }, -- [10]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["XT-002 Deconstructor"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [5] = {
                    ["name"] = BabbleBoss["The Iron Council"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-The Iron Council"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-The Iron Council"],} }, --optional
                    ["ratext"] = L["ra-The Iron Council"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_council",
                            ["btnId"] = 13,
                            ["buttons"] = {
                            	{
                                    ["y"] = -312.4999686660476,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 249.4078969956426,
                                }, -- [1]
                                {
                                    ["y"] = -369.7371524879578,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 62.10521322926339,
                                }, -- [2]
                                {
                                    ["y"] = -238.4869045833443,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 225.5263428468709,
                                }, -- [3]
                                {
                                    ["y"] = -349.0133694837836,
                                    ["type"] = "x",
                                    ["caption"] = " ",
                                    ["x"] = 79.07895369788345,
                                }, -- [4]
                                {
                                    ["y"] = -336.1844540087422,
                                    ["type"] = "y",
                                    ["caption"] = " ",
                                    ["x"] = 266.1841680721146,
                                }, -- [5]
                                {
                                    ["y"] = -355.9212320158952,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 172.0394458203141,
                                }, -- [6]
                                {
                                    ["y"] = -310.5261540798447,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 168.8816160533647,
                                }, -- [7]
                                {
                                    ["y"] = -365.7894060708483,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 271.3157538029151,
                                }, -- [8]
                                {
                                    ["y"] = -350.9869104990113,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 383.2236544242892,
                                }, -- [9]
                                {
                                    ["y"] = -312.5000077476155,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 287.8947997470385,
                                }, -- [10]
                                {
                                    ["y"] = -407.236854834493,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 173.8157617031931,
                                }, -- [11]
                                {
                                    ["y"] = -313.486915040717,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 363.2895535808677,
                                }, -- [12]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Stormcaller Brundir"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                    [6] = {
                                        ["type"] = "x",
                                        ["caption"] = BabbleBoss["Runemaster Molgeim"],
                                        ["r"] = 167/255,
                                        ["g"] = 31/255,
                                        ["b"] = 159/255,
                                    },
                                    [7] = {
                                        ["type"] = "y",
                                        ["caption"] = BabbleBoss["Steelbreaker"],
                                        ["r"] = 215/255,
                                        ["g"] = 121/255,
                                        ["b"] = 210/255,
                                    },
                                },
                            },
                        },
                    },
                },
                [6] = {
                    ["name"] = BabbleBoss["Kologarn"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Kologarn"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Kologarn"],} }, --optional
                    ["ratext"] = L["ra-Kologarn"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_kologarn",
                            ["btnId"] = 11,
                            ["buttons"] = {
                            	{
                                    ["y"] = -184.2105012630903,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 142.8289147117295,
                                }, -- [1]
                                {
                                    ["y"] = -338.1578386976984,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 179.7368732684747,
                                }, -- [2]
                                {
                                    ["y"] = -339.144687368448,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 234.2105603434293,
                                }, -- [3]
                                {
                                    ["y"] = -182.2367257584553,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 267.3683982014846,
                                }, -- [4]
                                {
                                    ["y"] = -182.2368039215911,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 191.3815781549302,
                                }, -- [5]
                                {
                                    ["y"] = -266.1183351710067,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 235.1972331471234,
                                }, -- [6]
                                {
                                    ["y"] = -269.0789593463913,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 183.6841897883374,
                                }, -- [7]
                                {
                                    ["y"] = -268.0920325125059,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 124.4737385221748,
                                }, -- [8]
                                {
                                    ["y"] = -182.2367257584553,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 115.1973375681876,
                                }, -- [9]
                                {
                                    ["y"] = -340.1316142023334,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 123.4868312290733,
                                }, -- [10]
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Kologarn"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [7] = {
                    ["name"] = BabbleBoss["Auriaya"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Auriaya"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Auriaya"],} }, --optional
                    ["ratext"] = L["ra-Auriaya"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_auriaya",
                            ["btnId"] = 5,
                            ["buttons"] = {
                            	{
                                    ["y"] = -116.1184705825329,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 267.9605230365615,
                                }, -- [1]
                                {
                                    ["y"] = -140.7895701065698,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 273.2895293075502,
                                }, -- [2]
                                {
                                    ["y"] = -118.0921483832482,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 400.0000818270328,
                                }, -- [3]
                                {
                                    ["y"] = -190.1317496138596,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 449.934210302344,
                                }, -- [4]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L["Group"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Auriaya"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [8] = {
                    ["name"] = BabbleBoss["Hodir"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Hodir"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Hodir"],} }, --optional
                    ["ratext"] = L["ra-Hodir"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_hodir",
                            ["btnId"] = 11,
                            ["buttons"] = {
                            	{
                                    ["y"] = -134.8686246379516,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 245.4606000165639,
                                }, -- [1]
                                {
                                    ["y"] = -241.447509217945,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 185.6578675890527,
                                }, -- [2]
                                {
                                    ["y"] = -314.4737441706827,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 243.0921006762562,
                                }, -- [3]
                                {
                                    ["y"] = -155.5920754487988,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 302.8948135629834,
                                }, -- [4]
                                {
                                    ["y"] = -149.670993194693,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 268.947430329663,
                                }, -- [5]
                                {
                                    ["y"] = -319.4077334942395,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 290.4605242196949,
                                }, -- [6]
                                {
                                    ["y"] = -159.539558065325,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 241.5132248743493,
                                }, -- [7]
                                {
                                    ["y"] = -241.4472356469698,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 314.9341836627597,
                                }, -- [8]
                                {
                                    ["y"] = -318.4210411497614,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 163.9473922404005,
                                }, -- [9]
                                {
                                    ["y"] = -314.4737441706827,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 371.184264783729,
                                }, -- [10]
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Hodir"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [9] = {
                    ["name"] = BabbleBoss["Freya"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Freya"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Freya"],} }, --optional
                    ["ratext"] = L["ra-Freya"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_freya",
                            ["btnId"] = 11,
                            ["buttons"] = {
                            	{
                                    ["y"] = -273.0263931109577,
                                    ["type"] = "n",
                                    ["x"] = 218.8158031510278,
                                    ["caption"] = " ",
                                }, -- [1]
                                {
                                    ["y"] = -270.0657298540052,
                                    ["type"] = "f",
                                    ["x"] = 169.8684647241143,
                                    ["caption"] = " ",
                                }, -- [2]
                                {
                                    ["y"] = -212.8288391438541,
                                    ["type"] = "h",
                                    ["x"] = 254.9341870213319,
                                    ["caption"] = " ",
                                }, -- [3]
                                {
                                    ["y"] = -164.4736646335855,
                                    ["type"] = "t",
                                    ["x"] = 214.0789412558999,
                                    ["caption"] = " ",
                                }, -- [4]
                                {
                                    ["y"] = -181.2500920363291,
                                    ["type"] = "b",
                                    ["x"] = 194.9341708391202,
                                    ["caption"] = " ",
                                }, -- [5]
                                {
                                    ["y"] = -285.8552108820794,
                                    ["type"] = "t",
                                    ["x"] = 257.5000091979081,
                                    ["caption"] = " ",
                                }, -- [6]
                                {
                                    ["y"] = -258.2237021312812,
                                    ["type"] = "n",
                                    ["x"] = 267.1710753652161,
                                    ["caption"] = " ",
                                }, -- [7]
                                {
                                    ["y"] = -225.6581258937905,
                                    ["type"] = "h",
                                    ["x"] = 281.5788275605965,
                                    ["caption"] = " ",
                                }, -- [8]
                                {
                                    ["y"] = -247.3682885898996,
                                    ["type"] = "f",
                                    ["x"] = 340.5920732351943,
                                    ["caption"] = " ",
                                }, -- [9]
                                {
                                    ["y"] = -293.7499807072924,
                                    ["type"] = "f",
                                    ["x"] = 322.828855784053,
                                    ["caption"] = " ",
                                }, -- [10]
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Freya"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [10] = {
                    ["name"] = BabbleBoss["Thorim"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Thorim"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Thorim"],} }, --optional
                    ["ratext"] = L["ra-Thorim"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_thorim",
                            ["btnId"] = 12,
                            ["buttons"] = {
                            	{
                                    ["y"] = -231.5790029696648,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 239.5395275328501,
                                }, -- [1]
                                {
                                    ["y"] = -229.6052274650298,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 165.9210309595479,
                                }, -- [2]
                                {
                                    ["y"] = -285.8552108820794,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 192.7631311205685,
                                }, -- [3]
                                {
                                    ["y"] = -191.1184028767698,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 250.5921662065804,
                                }, -- [4]
                                {
                                    ["y"] = -210.8553176694104,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 257.1052462806675,
                                }, -- [5]
                                {
                                    ["y"] = -193.092100218269,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 269.3421737061196,
                                }, -- [6]
                                {
                                    ["y"] = -235.5264758157991,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 274.078820652624,
                                }, -- [7]
                                {
                                    ["y"] = -292.7631515773267,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 259.8683717527282,
                                }, -- [8]
                                {
                                    ["y"] = -274.0130659146518,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 320.8551584425537,
                                }, -- [9]
                                {
                                    ["y"] = -217.7631215791701,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 337.631683549217,
                                }, -- [10]
                                {
                                    ["y"] = -176.3156923563094,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 198.486841686446,
                                }, -- [11]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 3"],
                                },
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Thorim"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [11] = {
                    ["name"] = BabbleBoss["Mimiron"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Mimiron"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Mimiron"],} }, --optional
                    ["ratext"] = L["ra-Mimiron"],
                    ["imgdata"] = {
                       [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_mimiron",
                            ["btnId"] = 10,
                            ["buttons"] = {
                            	{
                                    ["y"] = -239.4736360093903,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 213.8815207157118,
                                }, -- [1]
                                {
                                    ["y"] = -315.4603974335929,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 119.539377923723,
                                }, -- [2]
                                {
                                    ["y"] = -350.9869495805792,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 184.8684394584913,
                                }, -- [3]
                                {
                                    ["y"] = -215.7894242376709,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 247.6316006535476,
                                }, -- [4]
                                {
                                    ["y"] = -237.5000168310268,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 246.2499695247735,
                                }, -- [5]
                                {
                                    ["y"] = -247.3684253753872,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 280.9868395110071,
                                }, -- [6]
                                {
                                    ["y"] = -353.9476519190997,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 303.2894201539524,
                                }, -- [7]
                                {
                                    ["y"] = -424.013125910965,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 240.9210218761366,
                                }, -- [8]
                                {
                                    ["y"] = -325.3291772528482,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 376.1186644637486,
                                }, -- [9]
                        	},
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 1"],
                                },
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Leviathan Mk II"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [2] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_mimiron",
                            ["btnId"] = 9,
                            ["buttons"] = {
                            	{
                                    ["y"] = -234.5395880634816,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 242.3025553009911,
                                }, -- [1]
                                {
                                    ["y"] = -228.6184178758481,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 208.9474141474512,
                                }, -- [2]
                                {
                                    ["y"] = -262.1710381919279,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 129.6052851714074,
                                }, -- [3]
                                {
                                    ["y"] = -239.4737923356618,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 54.4079127961984,
                                }, -- [4]
                                {
                                    ["y"] = -221.7105944253044,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 268.1577872504781,
                                }, -- [5]
                                {
                                    ["y"] = -305.5919693484485,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 176.9736696332783,
                                }, -- [6]
                                {
                                    ["y"] = -317.4343488052833,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 64.27632622575483,
                                }, -- [7]
                                {
                                    ["y"] = -378.618243382754,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 129.407933023963,
                                }, -- [8]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 200,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 2 & 4"],
                                },
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["VX-001"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [3] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_mimiron",
                            ["btnId"] = 5,
                            ["buttons"] = {
                            	{
                                    ["y"] = -366.7762156600301,
                                    ["type"] = "t",
                                    ["x"] = 240.723738121436,
                                    ["caption"] = L["range tank"],
                                }, -- [1]
                                {
                                    ["y"] = -294.7369270819618,
                                    ["type"] = "b",
                                    ["x"] = 204.8026966281843,
                                    ["caption"] = " ",
                                }, -- [2]
                                {
                                    ["y"] = -450.6579227765012,
                                    ["type"] = "h",
                                    ["x"] = 164.1447541582369,
                                    ["caption"] = " ",
                                }, -- [3]
                                {
                                    ["y"] = -283.8815135405802,
                                    ["type"] = "t",
                                    ["x"] = 88.74997101323163,
                                    ["caption"] = " ",
                                }, -- [4]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 3"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L["Group"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Aerial Command Unit"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [12] = {
                    ["name"] = BabbleBoss["General Vezax"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-General Vezax"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-General Vezax"],} }, --optional
                    ["ratext"] = L["ra-General Vezax"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_vezax",
                            ["btnId"] = 11,
                            ["buttons"] = {
                            	{
                                    ["y"] = -117.9841416186671,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 271.5053355751659,
                                }, -- [1]
                                {
                                    ["y"] = -218.0770297372238,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 210.185988930524,
                                }, -- [2]
                                {
                                    ["y"] = -151.7111165202121,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 253.4032296643908,
                                }, -- [3]
                                {
                                    ["y"] = -160.4148873860085,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 277.7319774843008,
                                }, -- [4]
                                {
                                    ["y"] = -132.127780521768,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 287.9168434835863,
                                }, -- [5]
                                {
                                    ["y"] = -119.072115226128,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 310.6723674498672,
                                }, -- [6]
                                {
                                    ["y"] = -156.0630289439463,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 306.7137474941223,
                                }, -- [7]
                                {
                                    ["y"] = -244.1882703590505,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 206.922005129524,
                                }, -- [8]
                                {
                                    ["y"] = -227.8688731768797,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 313.5426809111741,
                                }, -- [9]
                                {
                                    ["y"] = -255.0679164642061,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 313.542788874518,
                                }, -- [10]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["General Vezax"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [13] = {
                    ["name"] = BabbleBoss["Yogg-Saron"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Yogg"],} },
                    ["ratext"] = L["ra-Yogg"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_yogg",
                            ["btnId"] = 8,
                            ["buttons"] = {
                            	{
                                    ["y"] = -490.1315569539429,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 251.7763572543825,
                                }, -- [1]
                                {
                                    ["y"] = -236.5132072418451,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 363.4868373355683,
                                }, -- [2]
                                {
                                    ["y"] = -391.4474324287706,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 251.5789367141943,
                                }, -- [3]
                                {
                                    ["y"] = -182.2369407070787,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 249.2105741593742,
                                }, -- [4]
                                {
                                    ["y"] = -239.4737923356618,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 107.8947121188354,
                                }, -- [5]
                                {
                                    ["y"] = -137.8288873088333,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 200.6579204865655,
                                }, -- [6]
                                {
                                    ["y"] = -144.7367889225128,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 372.368436290747,
                                }, -- [7]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 1"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L["Cloud"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L["Group"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Sara"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [2] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_yogg",
                            ["btnId"] = 6,
                            ["buttons"] = {
                            	{
									["y"] = -196.0525485265982,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 254.1447784315544,
                                }, -- [1]
                                {
                                    ["y"] = -384.5396089782269,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 392.8947401323812,
                                }, -- [2]
                                {
                                    ["y"] = -359.8683140463506,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 317.1053015444471,
                                }, -- [3]
                                {
                                    ["y"] = -317.4341729382279,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 412.43411714013,
                                }, -- [4]
                                {
                                    ["y"] = -344.078969803764,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 471.0526389790551,
                                }, -- [5]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 2"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L["Group"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Yogg-Saron"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [3] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_yogg",
                            ["btnId"] = 6,
                            ["buttons"] = {
                            	{
                                    ["y"] = -527.6314937898854,
                                    ["type"] = "y",
                                    ["caption"] = " ",
                                    ["x"] = 254.3420231046871,
                                }, -- [1]
                                {
                                    ["y"] = -189.1447055352705,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 249.2105741593742,
                                }, -- [2]
                                {
                                    ["y"] = -359.8682749647827,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 249.8026208313153,
                                }, -- [3]
                                {
                                    ["y"] = -427.9605987570993,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 250.0000218307196,
                                }, -- [4]
                                {
                                    ["y"] = -394.40778303318,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 249.6051612095593,
                                }, -- [5]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 3"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "y",
                                        ["caption"] = L["Sanity Well"],
                                        ["r"] = 215/255,
                                        ["g"] = 121/255,
                                        ["b"] = 210/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Yogg-Saron"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [14] = {
                    ["name"] = BabbleBoss["Algalon the Observer"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-10-Algalon the Observer"],} },
                    ["ratext"] = L["ra-Algalon the Observer"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_algalon",
                            ["btnId"] = 12,
                            ["buttons"] = {
                            	{
                                    ["y"] = -446.7104890119348,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 227.3025610258301,
                                }, -- [1]
                                {
                                    ["y"] = -357.894733949555,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 277.2367481234932,
                                }, -- [2]
                                {
                                    ["y"] = -331.2499761655868,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 255.1315489391683,
                                }, -- [3]
                                {
                                    ["y"] = -356.9080806866448,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 251.5788390102746,
                                }, -- [4]
                                {
                                    ["y"] = -363.8158650556206,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 119.7368180046951,
                                }, -- [5]
                                {
                                    ["y"] = -355.9210366080558,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 386.1842785996739,
                                }, -- [6]
                                {
                                    ["y"] = -412.1710981882411,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 152.105208191405,
                                }, -- [7]
                                {
                                    ["y"] = -441.7762847397545,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 308.0261257228086,
                                }, -- [8]
                                {
                                    ["y"] = -309.5395398985024,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 240.5262198773282,
                                }, -- [9]
                                {
                                    ["y"] = -307.5656471491637,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 273.0920696857941,
                                }, -- [10]
                                {
                                    ["y"] = -411.1841322727878,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 355.3946469701671,
                                }, -- [11]
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Algalon the Observer"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
            },
            ["mode25"] = {
		    -- first boss
                [1] = {
                    ["name"] = BabbleBoss["Flame Leviathan"],
                    ["ratext"] = L["ra-Flame Leviathan"], --lines seperated by \n
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Flame Leviathan"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Flame Leviathan"],} }, --optional
                    ["actionBtn1"] = {
                    	["text"] = L["VehicleInfo"],
                    	["action"] = function () BT_Ulduar:VehicleInfo() end,
                    },
                    ["actionBtn2"] = {
                    	["text"] = L["VehicleCheck"],
                    	["action"] = function () BT_main:BT_SendDataMessage("{UlduarIlvl}") end,
                    	["raidleadOnly"] = true,
                    },
                    ["actionBtn3"] = {
                    	["text"] = L["Assign Vehicle"],
                    	["action"] = function () BT_Ulduar:ShowLeviathanTasks() end,
                    	["raidleadOnly"] = true,
                    },
                    ["imgdata"] = {
                        --first image
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_leviathan",
                            ["btnId"] = 12, --start id of new buttons set this to the number of buttons on your current image +1
                            ["buttons"] = {
								{
                                    ["y"] = -127.9604103717291,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 224.5395332576891,
                                }, -- [1]
                                {
                                    ["y"] = -117.1052606309307,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 320.0657303119923,
                                }, -- [2]
                                {
                                    ["y"] = -170.3945417094598,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 135.1316435898405,
                                }, -- [3]
                                {
                                    ["y"] = -283.8815917037159,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 220.7894614109591,
                                }, -- [4]
                                {
                                    ["y"] = -173.3552831295482,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 313.1578873206647,
                                }, -- [5]
                                {
                                    ["y"] = -204.9342061041287,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 172.631590196175,
                                }, -- [6]
                                {
                                    ["y"] = -287.8288691420107,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 142.8289635636894,
                                }, -- [7]
                                {
                                    ["y"] = -228.6183397127123,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 248.4209897025412,
                                }, -- [8]
                                {
                                    ["y"] = -230.5921152173473,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 57.96049570999644,
                                }, -- [9]
                                {
                                    ["y"] = -137.8288873088333,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 367.8289558542395,
                                }, -- [10]
                                {
                                    ["y"] = -208.8815226239914,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 364.8685270866943,
                                }, -- [11]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L["Chopper"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L["Demolisher"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L["Siege Engine"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Flame Leviathan"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                --second boss
                [2] = {
                    ["name"] = BabbleBoss["Ignis the Furnace Master"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Ignis the Furnace Master"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Ignis the Furnace Master"],} }, --optional
                    ["ratext"] = L["ra-Ignis the Furnace Master"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_ignis",
                            ["btnId"] = 10,
                            ["buttons"] = {
                            	{
						            ["y"] = -274.0773283233468,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 258.7070368975271,
                                }, -- [1]
                                {
                                    ["y"] = -371.5023702382173,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 214.6909214003661,
                                }, -- [2]
                                {
                                    ["y"] = -370.5183203462193,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 255.4862384340929,
                                }, -- [3]
                                {
                                    ["y"] = -216.9999874183343,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 272.9317832627436,
                                }, -- [4]
                                {
                                    ["y"] = -246.5227797384012,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 274.6317380882377,
                                }, -- [5]
                                {
                                    ["y"] = -242.5862742742681,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 167.6340723035294,
                                }, -- [6]
                                {
                                    ["y"] = -273.0931344802236,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 294.1342365329259,
                                }, -- [7]
                                {
                                    ["y"] = -372.486384142434,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 305.674996174541,
                                }, -- [8]
                                {
                                    ["y"] = -373.4703620588694,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 349.511748569679,
                                }, -- [9]
                          	},
                          	["legend"] = { --optional, puts buttons to the legend
				                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Ignis the Furnace Master"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                    [5] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                },
                            },
                        },
                    },
                },
                [3] = {
                    ["name"] = BabbleBoss["Razorscale"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Razorscale"],} },
                    ["ratext"] = L["ra-Razorscale"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_razorscale",
                            ["btnId"] = 26,
                            ["buttons"] = {
                            	{
                                    ["y"] = -168.4210006942321,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 386.5789242722108,
                                }, -- [1]
                                {
                                    ["y"] = -295.7236585080077,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 382.039521998839,
                                }, -- [2]
                                {
                                    ["y"] = -246.3815376230697,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 105.9210343181202,
                                }, -- [3]
                                {
                                    ["y"] = -190.1314955836683,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 249.6053566173987,
                                }, -- [4]
                                {
                                    ["y"] = -179.2762188277743,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 126.249976241918,
                                }, -- [5]
                                {
                                    ["y"] = -200.9867332579944,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 387.7630957792288,
                                }, -- [6]
                                {
                                    ["y"] = -178.2894092385926,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 430.0000312957868,
                                }, -- [7]
                                {
                                    ["y"] = -206.9078252824922,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 358.9473178174929,
                                }, -- [8]
                                {
                                    ["y"] = -155.5920754487988,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 124.0789853753262,
                                }, -- [9]
                                {
                                    ["y"] = -172.3683172140949,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 161.5789222112687,
                                }, -- [10]
                                {
                                    ["y"] = -184.2105012630903,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 100.394714981255,
                                }, -- [11]
                                {
                                    ["y"] = -270.0657298540052,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 146.3815562478794,
                                }, -- [12]
                                {
                                    ["y"] = -221.7103599358971,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 178.9474842194812,
                                }, -- [13]
                                {
                                    ["y"] = -248.3554889947602,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 440.4605255936563,
                                }, -- [14]
                                {
                                    ["y"] = -251.3158395991697,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 394.0788334762635,
                                }, -- [15]
                                {
                                    ["y"] = -247.3684253753872,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 337.8290063854855,
                                }, -- [16]
                                {
                                    ["y"] = -246.3816353269895,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 238.1579550264278,
                                }, -- [17]
                                {
                                    ["y"] = -220.7237848361227,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 310.9868866836809,
                                }, -- [18]
                                {
                                    ["y"] = -269.0789593463913,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 275.4606081076697,
                                }, -- [19]
                                {
                                    ["y"] = -236.5132072418451,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 61.31573136154611,
                                }, -- [20]
                                {
                                    ["y"] = -226.6445642080773,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 471.8420866504005,
                                }, -- [21]
                                {
                                    ["y"] = -201.973621010312,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 52.43420568430719,
                                }, -- [22]
                                {
                                    ["y"] = -230.5920370542115,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 142.2368289582205,
                                }, -- [23]
                                {
                                    ["y"] = -220.7235503467153,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 101.7763167988532,
                                }, -- [24]
                                {
                                    ["y"] = -222.6972476882146,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 425.4605117777114,
                                }, -- [25]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 1"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                },
                            },
                        },
                        [2] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_razorscale",
                            ["btnId"] = 27,
                            ["buttons"] = {
                            	{
                                    ["y"] = -255.2630584151127,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 253.1578906792369,
                                }, -- [1]
                                {
                                    ["y"] = -187.1710081937713,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 99.6052966210855,
                                }, -- [2]
                                {
                                    ["y"] = -220.7235503467153,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 212.89471112653,
                                }, -- [3]
                                {
                                    ["y"] = -255.2630584151127,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 404.9341688545093,
                                }, -- [4]
                                {
                                    ["y"] = -243.4210306923887,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 103.7499945995685,
                                }, -- [5]
                                {
                                    ["y"] = -164.4736060112337,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 427.2368081198064,
                                }, -- [6]
                                {
                                    ["y"] = -198.026382653585,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 446.9736252085273,
                                }, -- [7]
                                {
                                    ["y"] = -208.8814444608557,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 249.4079360772105,
                                }, -- [8]
                                {
                                    ["y"] = -207.8946348716739,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 230.6577917921838,
                                }, -- [9]
                                {
                                    ["y"] = -219.7368189206694,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 300.723676140512,
                                }, -- [10]
                                {
                                    ["y"] = -209.8682540500374,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 287.8947215839027,
                                }, -- [11]
                                {
                                    ["y"] = -205.9210352340944,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 310.5920651440885,
                                }, -- [12]
                                {
                                    ["y"] = -216.7762924492045,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 399.0131940747153,
                                }, -- [13]
                                {
                                    ["y"] = -180.2629697946042,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 388.1578586964694,
                                }, -- [14]
                                {
                                    ["y"] = -226.6446423712131,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 365.4604565139318,
                                }, -- [15]
                                {
                                    ["y"] = -215.7893460745351,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 155.2630965807063,
                                }, -- [16]
                                {
                                    ["y"] = -194.0789098074508,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 185.8552881292409,
                                }, -- [17]
                                {
                                    ["y"] = -177.302541027059,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 218.4210206930032,
                                }, -- [18]
                                {
                                    ["y"] = -218.7499311683519,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 116.5789296153939,
                                }, -- [19]
                                {
                                    ["y"] = -195.0657193966325,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 135.3289761965009,
                                }, -- [20]
                                {
                                    ["y"] = -174.3420145555941,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 157.0394808563291,
                                }, -- [21]
                                {
                                    ["y"] = -245.3946694115362,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 443.223631524933,
                                }, -- [22]
                                {
                                    ["y"] = -153.6183292553397,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 396.8422129785154,
                                }, -- [23]
                                {
                                    ["y"] = -154.605275630009,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 360.3290075686189,
                                }, -- [24]
                                {
                                    ["y"] = -189.1447055352705,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 424.4736631069617,
                                }, -- [25]
                                {
                                    ["y"] = -222.6973258513503,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 434.3420716513222,
                                }, -- [26]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 2"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Razorscale"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [3] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_razorscale",
                            ["btnId"] = 14,
                            ["buttons"] = {
                            	{
                                    ["y"] = -261.1840722764746,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 266.9737720697316,
                                }, -- [1]
                                {
                                    ["y"] = -189.1446078313508,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 233.2236335095439,
                                }, -- [2]
                                {
                                    ["y"] = -213.8158050593074,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 177.7631563861915,
                                }, -- [3]
                                {
                                    ["y"] = -222.6973258513503,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 252.3684820894594,
                                }, -- [4]
                                {
                                    ["y"] = -286.8419813896932,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 279.2105040873443,
                                }, -- [5]
                                {
                                    ["y"] = -246.3815376230697,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 356.7763367212931,
                                }, -- [6]
                                {
                                    ["y"] = -194.0790661337223,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 350.8552056152275,
                                }, -- [7]
                                {
                                    ["y"] = -257.2369120828835,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 302.8947549406315,
                                }, -- [8]
                                {
                                    ["y"] = -232.5657343957108,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 287.8947215839027,
                                }, -- [9]
                                {
                                    ["y"] = -184.2105012630903,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 293.4210897727277,
                                }, -- [10]
                                {
                                    ["y"] = -167.4340347787789,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 211.3157571614874,
                                }, -- [11]
                                {
                                    ["y"] = -161.5130795397687,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 250.7895085836329,
                                }, -- [12]
                                {
                                    ["y"] = -190.1314955836683,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 182.6973801991557,
                                }, -- [13]

                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 3"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = L["Razorscale cite"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [4] = {
                    ["name"] = BabbleBoss["XT-002 Deconstructor"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-XT-002 Deconstructor"],} },
                    ["ratext"] = L["ra-XT-002 Deconstructor"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_xt",
                            ["btnId"] = 12,
                            ["buttons"] = {
                            	{
                                    ["y"] = -159.3268328060397,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 254.1901564842918,
                                }, -- [1]
                                {
                                    ["y"] = -166.9426390613206,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 229.0747517528404,
                                }, -- [2]
                                {
                                    ["y"] = -197.4056481557562,
                                    ["type"] = "f",
                                    ["caption"] = L["Camp1"],
                                    ["x"] = 163.4032047822138,
                                }, -- [3]
                                {
                                    ["y"] = -223.5170147348175,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 231.6440094296422,
                                }, -- [4]
                                {
                                    ["y"] = -138.6554602215174,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 253.7967200651773,
                                }, -- [5]
                                {
                                    ["y"] = -165.854728432477,
                                    ["type"] = "n",
                                    ["caption"] = L["Lightbomb"],
                                    ["x"] = 283.4731622175249,
                                }, -- [6]
                                {
                                    ["y"] = -221.3410495260051,
                                    ["type"] = "f",
                                    ["caption"] = BabbleClass["Hunter"],
                                    ["x"] = 253.7046993083809,
                                }, -- [7]
                                {
                                    ["y"] = -200.6697399201001,
                                    ["type"] = "f",
                                    ["caption"] = L["Camp2"],
                                    ["x"] = 345.0938165611412,
                                }, -- [8]
                                {
                                    ["y"] = -237.6605186837385,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 234.9081731695486,
                                }, -- [9]
                                {
                                    ["y"] = -236.5726620365668,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 257.7553040331408,
                                }, -- [10]
                                {
										["y"] = -158.2389941527587,
										["type"] = "t",
										["caption"] = " ",
										["x"] = 353.8897701287498,
								},
							},
							["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["XT-002 Deconstructor"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [5] = {
                    ["name"] = BabbleBoss["The Iron Council"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-The Iron Council"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-The Iron Council"],} }, --optional
                    ["ratext"] = L["ra-The Iron Council"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_council",
                            ["btnId"] = 27,
                            ["buttons"] = {
                            	{
                                    ["y"] = -326.3156351079189,
                                    ["x"] = 80.06580236863307,
                                    ["caption"] = " ",
                                    ["type"] = "x",
                                }, -- [1]
                                {
                                    ["y"] = -343.0920429698786,
                                    ["x"] = 243.4868440527128,
                                    ["caption"] = " ",
                                    ["type"] = "y",
                                }, -- [2]
                                {
                                    ["y"] = -239.4736360093903,
                                    ["x"] = 211.710520078728,
                                    ["caption"] = " ",
                                    ["type"] = "b",
                                }, -- [3]
                                {
                                    ["y"] = -314.473626925979,
                                    ["x"] = 237.5657911097829,
                                    ["caption"] = " ",
                                    ["type"] = "n",
                                }, -- [4]
                                {
                                    ["y"] = -322.3684944551117,
                                    ["x"] = 264.2106661384548,
                                    ["caption"] = " ",
                                    ["type"] = "n",
                                }, -- [5]
                                {
                                    ["y"] = -345.0657403113778,
                                    ["x"] = 55.19739466391569,
                                    ["caption"] = " ",
                                    ["type"] = "t",
                                }, -- [6]
                                {
                                    ["y"] = -227.6316082866664,
                                    ["x"] = 246.0525685253693,
                                    ["caption"] = " ",
                                    ["type"] = "h",
                                }, -- [7]
                                {
                                    ["y"] = -322.3683772104081,
                                    ["x"] = 212.89471112653,
                                    ["caption"] = " ",
                                    ["type"] = "n",
                                }, -- [8]
                                {
                                    ["y"] = -220.7237066729869,
                                    ["x"] = 211.1184538660029,
                                    ["caption"] = " ",
                                    ["type"] = "t",
                                }, -- [9]
                                {
                                    ["y"] = -367.763298820187,
                                    ["x"] = 243.6841864297652,
                                    ["caption"] = " ",
                                    ["type"] = "t",
                                }, -- [10]
                                {
                                    ["y"] = -356.9079243603733,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 365.4606519217712,
                                }, -- [11]
                                {
                                    ["y"] = -320.3946798689088,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 354.6053165435254,
                                }, -- [12]
                                {
                                    ["y"] = -329.276474231927,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 400.9869304977824,
                                }, -- [13]
                                {
                                    ["y"] = -381.5790238844102,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 113.8158041433332,
                                }, -- [14]
                                {
                                    ["y"] = -381.579062965978,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 163.1578566355274,
                                }, -- [15]
                                {
                                    ["y"] = -345.0657403113778,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 139.4736937157678,
                                }, -- [16]
                                {
                                    ["y"] = -307.5658034754353,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 159.9999780166181,
                                }, -- [17]
                                {
                                    ["y"] = -371.7106544216176,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 444.2103238694111,
                                }, -- [18]
                                {
                                    ["y"] = -303.6185651187084,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 316.9079005450428,
                                }, -- [19]
                                {
                                    ["y"] = -362.8291336295747,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 316.9079005450428,
                                }, -- [20]
                                {
                                    ["y"] = -331.2499761655868,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 463.9474536106751,
                                }, -- [21]
                                {
                                    ["y"] = -293.75011749278,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 279.4080027906682,
                                }, -- [22]
                                {
                                    ["y"] = -298.6843803873121,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 236.9737053562739,
                                }, -- [23]
                                {
                                    ["y"] = -297.697336308723,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 206.3815528893072,
                                }, -- [24]
                                {
                                    ["y"] = -396.3815585378151,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 72.17118886969159,
                                }, -- [25]
                                {
                                    ["y"] = -314.4736660075469,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 122.5000607214595,
                                }, -- [26]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Stormcaller Brundir"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                    [6] = {
                                        ["type"] = "x",
                                        ["caption"] = BabbleBoss["Runemaster Molgeim"],
                                        ["r"] = 167/255,
                                        ["g"] = 31/255,
                                        ["b"] = 159/255,
                                    },
                                    [7] = {
                                        ["type"] = "y",
                                        ["caption"] = BabbleBoss["Steelbreaker"],
                                        ["r"] = 215/255,
                                        ["g"] = 121/255,
                                        ["b"] = 210/255,
                                    },
                                },
                            },
                        },
                    },
                },
                [6] = {
                    ["name"] = BabbleBoss["Kologarn"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Kologarn"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Kologarn"],} }, --optional
                    ["ratext"] = L["ra-Kologarn"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_kologarn",
                            ["btnId"] = 26,
                            ["buttons"] = {
                            	{
                                    ["y"] = -184.2106575893619,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 266.3816276938707,
                                }, -- [1]
                                {
                                    ["y"] = -271.0526566878905,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 233.2236725911118,
                                }, -- [2]
                                {
                                    ["y"] = -169.4078884465497,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 137.8947104395493,
                                }, -- [3]
                                {
                                    ["y"] = -340.1315360391976,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 134.3421079849673,
                                }, -- [4]
                                {
                                    ["y"] = -184.2105012630903,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 240.723738121436,
                                }, -- [5]
                                {
                                    ["y"] = -173.3552049664124,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 183.486847411285,
                                }, -- [6]
                                {
                                    ["y"] = -166.4474010566526,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 116.1841276165854,
                                }, -- [7]
                                {
                                    ["y"] = -188.157817782953,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 118.1578835804365,
                                }, -- [8]
                                {
                                    ["y"] = -188.157817782953,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 143.8157926936551,
                                }, -- [9]
                                {
                                    ["y"] = -179.2762969909101,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 102.3684220931462,
                                }, -- [10]
                                {
                                    ["y"] = -272.0395248994241,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 283.5526616875833,
                                }, -- [11]
                                {
                                    ["y"] = -342.1051552175611,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 234.2105994249972,
                                }, -- [12]
                                {
                                    ["y"] = -339.144687368448,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 284.5395298991169,
                                }, -- [13]
                                {
                                    ["y"] = -343.0920820514465,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 185.8552881292409,
                                }, -- [14]
                                {
                                    ["y"] = -273.0263344886059,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 183.8816298693096,
                                }, -- [15]
                                {
                                    ["y"] = -272.0395248994241,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 134.3420982145754,
                                }, -- [16]
                                {
                                    ["y"] = -336.1841022746312,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 84.99998710002934,
                                }, -- [17]
                                {
                                    ["y"] = -271.0526566878905,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 86.97368444152859,
                                }, -- [18]
                                {
                                    ["y"] = -418.0920729680352,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 186.6447162598024,
                                }, -- [19]
                                {
                                    ["y"] = -415.1313315479468,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 235.9868762263082,
                                }, -- [20]
                                {
                                    ["y"] = -270.0657298540052,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 332.6973620323331,
                                }, -- [21]
                                {
                                    ["y"] = -342.1051942991289,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 329.7369332647879,
                                }, -- [22]
                                {
                                    ["y"] = -415.13164420049,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 282.3684315582134,
                                }, -- [23]
                                {
                                    ["y"] = -418.0920338864673,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 331.7105133615835,
                                }, -- [24]
                                {
                                    ["y"] = -335.1972926854495,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 38.61844886631013,
                                }, -- [25]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Kologarn"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [7] = {
                    ["name"] = BabbleBoss["Auriaya"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Auriaya"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Auriaya"],} }, --optional
                    ["ratext"] = L["ra-Auriaya"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_auriaya",
                            ["btnId"] = 7,
                            ["buttons"] = {
                            	{
									["y"] = -117.1052606309307,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 245.2631794763757,
                                }, -- [1]
                                {
                                    ["y"] = -116.1183728786132,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 267.3683786607006,
                                }, -- [2]
                                {
                                    ["y"] = -139.8026628134683,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 403.9473983468955,
                                }, -- [3]
                                {
                                    ["y"] = -196.052626689734,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 258.4868187870898,
                                }, -- [4]
                                {
                                    ["y"] = -195.0657193966325,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 464.7369012820205,
                                }, -- [5]
                                {
                                    ["y"] = -110.1972808541155,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 390.7236808730456,
                                }, -- [6]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L["Group"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Auriaya"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [8] = {
                    ["name"] = BabbleBoss["Hodir"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Hodir"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Hodir"],} }, --optional
                    ["ratext"] = L["ra-Hodir"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_hodir",
                            ["btnId"] = 19,
                            ["buttons"] = {
                            	{
									["y"] = -155.5920754487988,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 290.6580033822349,
                                }, -- [1]
                                {
                                    ["y"] = -162.4999868328702,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 323.6184597816699,
                                }, -- [2]
                                {
                                    ["y"] = -270.0658275579249,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 262.8288786834091,
                                }, -- [3]
                                {
                                    ["y"] = -146.7106523606755,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 263.2236611414337,
                                }, -- [4]
                                {
                                    ["y"] = -216.7764096939081,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 151.1183790614394,
                                }, -- [5]
                                {
                                    ["y"] = -315.4607687084878,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 271.7105558017236,
                                }, -- [6]
                                {
                                    ["y"] = -313.4868368775812,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 220.3946594121506,
                                }, -- [7]
                                {
                                    ["y"] = -315.4604755967286,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 319.0789988859463,
                                }, -- [8]
                                {
                                    ["y"] = -269.0790961318789,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 318.0920915928449,
                                }, -- [9]
                                {
                                    ["y"] = -274.0131636185715,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 218.4210206930032,
                                }, -- [10]
                                {
                                    ["y"] = -272.0393685731526,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 134.3420982145754,
                                }, -- [11]
                                {
                                    ["y"] = -326.3158891381102,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 129.4078939423951,
                                }, -- [12]
                                {
                                    ["y"] = -221.7104967213847,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 199.4736903571956,
                                }, -- [13]
                                {
                                    ["y"] = -280.9211238546029,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 180.7236633168725,
                                }, -- [14]
                                {
                                    ["y"] = -223.6842136036679,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 336.6448348784674,
                                }, -- [15]
                                {
                                    ["y"] = -270.0658275579249,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 378.0920491527048,
                                }, -- [16]
                                {
                                    ["y"] = -319.4077334942395,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 395.85528614463,
                                }, -- [17]
                                {
                                    ["y"] = -219.7368970838052,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 258.6841220825743,
                                }, -- [18]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Hodir"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [9] = {
                    ["name"] = BabbleBoss["Freya"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Freya"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Freya"],} }, --optional
                    ["ratext"] = L["ra-Freya"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_freya",
                            ["btnId"] = 22,
                            ["buttons"] = {
                            	{
                                    ["y"] = -167.4342692681862,
                                    ["type"] = "t",
                                    ["x"] = 206.1841714306869,
                                    ["caption"] = " ",
                                }, -- [1]
                                {
                                    ["y"] = -187.1710081937713,
                                    ["type"] = "b",
                                    ["x"] = 183.0921626571802,
                                    ["caption"] = " ",
                                }, -- [2]
                                {
                                    ["y"] = -305.5919888892324,
                                    ["type"] = "t",
                                    ["x"] = 233.815680181485,
                                    ["caption"] = " ",
                                }, -- [3]
                                {
                                    ["y"] = -231.5788466433933,
                                    ["type"] = "t",
                                    ["x"] = 339.4079017281762,
                                    ["caption"] = " ",
                                }, -- [4]
                                {
                                    ["y"] = -284.8684403744655,
                                    ["type"] = "n",
                                    ["x"] = 213.8815988788475,
                                    ["caption"] = " ",
                                }, -- [5]
                                {
                                    ["y"] = -285.8553085859991,
                                    ["type"] = "n",
                                    ["x"] = 180.3289394811998,
                                    ["caption"] = " ",
                                }, -- [6]
                                {
                                    ["y"] = -199.9999236688127,
                                    ["type"] = "n",
                                    ["x"] = 343.1579344933384,
                                    ["caption"] = " ",
                                }, -- [7]
                                {
                                    ["y"] = -216.7762924492045,
                                    ["type"] = "n",
                                    ["x"] = 376.7104766462824,
                                    ["caption"] = " ",
                                }, -- [8]
                                {
                                    ["y"] = -358.8815435387368,
                                    ["type"] = "f",
                                    ["x"] = 184.6711361630068,
                                    ["caption"] = " ",
                                }, -- [9]
                                {
                                    ["y"] = -233.5525439848925,
                                    ["type"] = "h",
                                    ["x"] = 238.1577596185883,
                                    ["caption"] = " ",
                                }, -- [10]
                                {
                                    ["y"] = -214.8026928116249,
                                    ["type"] = "h",
                                    ["x"] = 277.6316673670053,
                                    ["caption"] = " ",
                                }, -- [11]
                                {
                                    ["y"] = -256.2501024937017,
                                    ["type"] = "h",
                                    ["x"] = 273.6842531432229,
                                    ["caption"] = " ",
                                }, -- [12]
                                {
                                    ["y"] = -345.0657012298099,
                                    ["type"] = "h",
                                    ["x"] = 314.1446578282785,
                                    ["caption"] = " ",
                                }, -- [13]
                                {
                                    ["y"] = -329.2763960687912,
                                    ["type"] = "h",
                                    ["x"] = 354.6051992988217,
                                    ["caption"] = " ",
                                }, -- [14]
                                {
                                    ["y"] = -368.7500693278009,
                                    ["type"] = "h",
                                    ["x"] = 350.6578046158232,
                                    ["caption"] = " ",
                                }, -- [15]
                                {
                                    ["y"] = -373.6842735999811,
                                    ["type"] = "f",
                                    ["x"] = 249.8026208313153,
                                    ["caption"] = " ",
                                }, -- [16]
                                {
                                    ["y"] = -312.499851421344,
                                    ["type"] = "f",
                                    ["x"] = 290.2631818426425,
                                    ["caption"] = " ",
                                }, -- [17]
                                {
                                    ["y"] = -287.8288691420107,
                                    ["type"] = "f",
                                    ["x"] = 333.6841716215149,
                                    ["caption"] = " ",
                                }, -- [18]
                                {
                                    ["y"] = -169.4077321202781,
                                    ["type"] = "f",
                                    ["x"] = 320.8551584425537,
                                    ["caption"] = " ",
                                }, -- [19]
                                {
                                    ["y"] = -270.0657298540052,
                                    ["type"] = "f",
                                    ["x"] = 391.9078914616316,
                                    ["caption"] = " ",
                                }, -- [20]
                                {
                                    ["y"] = -249.3420445537507,
                                    ["type"] = "f",
                                    ["x"] = 190.5920914020169,
                                    ["caption"] = " ",
                                }, -- [21]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Freya"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [10] = {
                    ["name"] = BabbleBoss["Thorim"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Thorim"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Thorim"],} }, --optional
                    ["ratext"] = L["ra-Thorim"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_thorim",
                            ["btnId"] = 25,
                            ["buttons"] = {
								{
                                    ["y"] = -214.8026928116249,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 257.1053049030193,
                                }, -- [1]
                                {
                                    ["y"] = -197.039338574996,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 235.789475226904,
                                }, -- [2]
                                {
                                    ["y"] = -223.6842136036679,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 230.6578308737517,
                                }, -- [3]
                                {
                                    ["y"] = -301.6447309917215,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 184.8683612953555,
                                }, -- [4]
                                {
                                    ["y"] = -313.4869541222848,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 243.8816069699534,
                                }, -- [5]
                                {
                                    ["y"] = -190.1314565021004,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 257.5000091979081,
                                }, -- [6]
                                {
                                    ["y"] = -201.973621010312,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 277.236806745845,
                                }, -- [7]
                                {
                                    ["y"] = -239.4736360093903,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 248.421048324893,
                                }, -- [8]
                                {
                                    ["y"] = -235.5264758157991,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 270.1315432143292,
                                }, -- [9]
                                {
                                    ["y"] = -224.6710231928496,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 287.8947215839027,
                                }, -- [10]
                                {
                                    ["y"] = -307.5657643938674,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 299.3421427156575,
                                }, -- [11]
                                {
                                    ["y"] = -361.842324040393,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 176.776288174658,
                                }, -- [12]
                                {
                                    ["y"] = -265.1317209896644,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 161.9737437508611,
                                }, -- [13]
                                {
                                    ["y"] = -159.5393919686615,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 316.1185114960493,
                                }, -- [14]
                                {
                                    ["y"] = -214.8025364853534,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 165.1315442066346,
                                }, -- [15]
                                {
                                    ["y"] = -153.6184660408273,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 212.4999482092894,
                                }, -- [16]
                                {
                                    ["y"] = -236.5132072418451,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 359.5395208157056,
                                }, -- [17]
                                {
                                    ["y"] = -164.4737623375052,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 133.55265054323,
                                }, -- [18]
                                {
                                    ["y"] = -311.5131004545141,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 132.3684008730761,
                                }, -- [19]
                                {
                                    ["y"] = -233.5528566374356,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 118.5525878753252,
                                }, -- [20]
                                {
                                    ["y"] = -304.6052183816186,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 388.9472672862469,
                                }, -- [21]
                                {
                                    ["y"] = -187.1708518674998,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 381.0528687359288,
                                }, -- [22]
                                {
                                    ["y"] = -130.9211420214254,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 281.3815828874638,
                                }, -- [23]
                                {
                                    ["y"] = -127.9604885348648,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 180.7236633168725,
                                }, -- [24]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 3"],
                                },
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Thorim"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [11] = {
                    ["name"] = BabbleBoss["Mimiron"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Mimiron"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-Mimiron"],} }, --optional
                    ["ratext"] = L["ra-Mimiron"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_mimiron",
                            ["btnId"] = 17,
                            ["buttons"] = {
                            	{
                                    ["y"] = -233.5527784742999,
                                    ["type"] = "n",
                                    ["x"] = 221.7762319185729,
                                    ["caption"] = " ",
                                }, -- [1]
                                {
                                    ["y"] = -273.0264712740935,
                                    ["type"] = "f",
                                    ["x"] = 74.14480316285908,
                                    ["caption"] = " ",
                                }, -- [2]
                                {
                                    ["y"] = -383.55252581807,
                                    ["type"] = "h",
                                    ["x"] = 222.3683958352178,
                                    ["caption"] = " ",
                                }, -- [3]
                                {
                                    ["y"] = -252.3026296475675,
                                    ["type"] = "t",
                                    ["x"] = 256.5131605271585,
                                    ["caption"] = " ",
                                }, -- [4]
                                {
                                    ["y"] = -234.5394121964261,
                                    ["type"] = "b",
                                    ["x"] = 244.2761744793545,
                                    ["caption"] = " ",
                                }, -- [5]
                                {
                                    ["y"] = -221.7106921292241,
                                    ["type"] = "n",
                                    ["x"] = 274.0789769788956,
                                    ["caption"] = " ",
                                }, -- [6]
                                {
                                    ["y"] = -204.9342842672645,
                                    ["type"] = "n",
                                    ["x"] = 243.4868831342807,
                                    ["caption"] = " ",
                                }, -- [7]
                                {
                                    ["y"] = -401.3157628099953,
                                    ["type"] = "f",
                                    ["x"] = 62.30265819543151,
                                    ["caption"] = " ",
                                }, -- [8]
                                {
                                    ["y"] = -472.3683199620176,
                                    ["type"] = "f",
                                    ["x"] = 118.5526464976771,
                                    ["caption"] = " ",
                                }, -- [9]
                                {
                                    ["y"] = -352.9605296773748,
                                    ["type"] = "h",
                                    ["x"] = 324.9999736657404,
                                    ["caption"] = " ",
                                }, -- [10]
                                {
                                    ["y"] = -331.2500934102905,
                                    ["type"] = "h",
                                    ["x"] = 254.9341870213319,
                                    ["caption"] = " ",
                                }, -- [11]
                                {
                                    ["y"] = -342.1052724622647,
                                    ["type"] = "h",
                                    ["x"] = 162.1710763575215,
                                    ["caption"] = " ",
                                }, -- [12]
                                {
                                    ["y"] = -312.5000077476155,
                                    ["type"] = "h",
                                    ["x"] = 334.8683822101008,
                                    ["caption"] = " ",
                                }, -- [13]
                                {
                                    ["y"] = -462.5000677439287,
                                    ["type"] = "f",
                                    ["x"] = 298.1578930455037,
                                    ["caption"] = " ",
                                }, -- [14]
                                {
                                    ["y"] = -413.157868695855,
                                    ["type"] = "f",
                                    ["x"] = 419.5394588347815,
                                    ["caption"] = " ",
                                }, -- [15]
                                {
                                    ["y"] = -335.1973317670174,
                                    ["type"] = "f",
                                    ["x"] = 452.1052695616796,
                                    ["caption"] = " ",
                                }, -- [16]
                        	},
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 1"],
                                },
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Leviathan Mk II"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [2] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_mimiron",
                            ["btnId"] = 24,
                            ["buttons"] = {
                            	{
                                    ["y"] = -240.4605237617078,
                                    ["type"] = "b",
                                    ["x"] = 250.197344666988,
                                    ["caption"] = " ",
                                }, -- [1]
                                {
                                    ["y"] = -215.7893460745351,
                                    ["type"] = "n",
                                    ["x"] = 232.6316259191706,
                                    ["caption"] = " ",
                                }, -- [2]
                                {
                                    ["y"] = -419.0791561281921,
                                    ["type"] = "f",
                                    ["x"] = 113.618393373537,
                                    ["caption"] = " ",
                                }, -- [3]
                                {
                                    ["y"] = -324.3420159295555,
                                    ["type"] = "h",
                                    ["x"] = 171.0525385272127,
                                    ["caption"] = " ",
                                }, -- [4]
                                {
                                    ["y"] = -224.6711013559854,
                                    ["type"] = "n",
                                    ["x"] = 277.0394839095766,
                                    ["caption"] = " ",
                                }, -- [5]
                                {
                                    ["y"] = -262.1710381919279,
                                    ["type"] = "n",
                                    ["x"] = 276.0526938611787,
                                    ["caption"] = " ",
                                }, -- [6]
                                {
                                    ["y"] = -266.1183351710067,
                                    ["type"] = "n",
                                    ["x"] = 236.579040142953,
                                    ["caption"] = " ",
                                }, -- [7]
                                {
                                    ["y"] = -244.4079770670581,
                                    ["type"] = "n",
                                    ["x"] = 217.8288958579263,
                                    ["caption"] = " ",
                                }, -- [8]
                                {
                                    ["y"] = -339.144687368448,
                                    ["type"] = "f",
                                    ["x"] = 41.57895335439311,
                                    ["caption"] = " ",
                                }, -- [9]
                                {
                                    ["y"] = -274.0131636185715,
                                    ["type"] = "h",
                                    ["x"] = 135.5262697215935,
                                    ["caption"] = " ",
                                }, -- [10]
                                {
                                    ["y"] = -223.6840572773963,
                                    ["type"] = "h",
                                    ["x"] = 126.6447196183746,
                                    ["caption"] = " ",
                                }, -- [11]
                                {
                                    ["y"] = -332.2365512653612,
                                    ["type"] = "h",
                                    ["x"] = 336.8422358778716,
                                    ["caption"] = " ",
                                }, -- [12]
                                {
                                    ["y"] = -287.8288496012268,
                                    ["type"] = "h",
                                    ["x"] = 377.3025233182236,
                                    ["caption"] = " ",
                                }, -- [13]
                                {
                                    ["y"] = -230.5920370542115,
                                    ["type"] = "h",
                                    ["x"] = 381.2500743274936,
                                    ["caption"] = " ",
                                }, -- [14]
                                {
                                    ["y"] = -172.3684735403664,
                                    ["type"] = "h",
                                    ["x"] = 229.2763169896812,
                                    ["caption"] = " ",
                                }, -- [15]
                                {
                                    ["y"] = -177.3025996494109,
                                    ["type"] = "h",
                                    ["x"] = 273.6841945208711,
                                    ["caption"] = " ",
                                }, -- [16]
                                {
                                    ["y"] = -219.7367212167497,
                                    ["type"] = "f",
                                    ["x"] = 41.57893869880515,
                                    ["caption"] = " ",
                                }, -- [17]
                                {
                                    ["y"] = -392.4341247732486,
                                    ["type"] = "f",
                                    ["x"] = 417.5657614932823,
                                    ["caption"] = " ",
                                }, -- [18]
                                {
                                    ["y"] = -303.6183110885171,
                                    ["type"] = "f",
                                    ["x"] = 441.2500123465695,
                                    ["caption"] = " ",
                                }, -- [19]
                                {
                                    ["y"] = -228.6184960389839,
                                    ["type"] = "f",
                                    ["x"] = 452.1052695616796,
                                    ["caption"] = " ",
                                }, -- [20]
                                {
                                    ["y"] = -146.71047649362,
                                    ["type"] = "f",
                                    ["x"] = 171.8421620656135,
                                    ["caption"] = " ",
                                }, -- [21]
                                {
                                    ["y"] = -140.7894821730421,
                                    ["type"] = "f",
                                    ["x"] = 244.8684360999191,
                                    ["caption"] = " ",
                                }, -- [22]
                                {
                                    ["y"] = -157.56578256069,
                                    ["type"] = "f",
                                    ["x"] = 326.7762700078354,
                                    ["caption"] = " ",
                                }, -- [23]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 200,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 2 & 4"],
                                },
                            },
                             ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["VX-001"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [3] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_mimiron",
                            ["btnId"] = 5,
                            ["buttons"] = {
                            	{
                                    ["y"] = -366.7762156600301,
                                    ["type"] = "t",
                                    ["x"] = 240.723738121436,
                                    ["caption"] = L["range tank"],
                                }, -- [1]
                                {
                                    ["y"] = -294.7369270819618,
                                    ["type"] = "b",
                                    ["x"] = 204.8026966281843,
                                    ["caption"] = " ",
                                }, -- [2]
                                {
                                    ["y"] = -450.6579227765012,
                                    ["type"] = "h",
                                    ["x"] = 164.1447541582369,
                                    ["caption"] = " ",
                                }, -- [3]
                                {
                                    ["y"] = -283.8815135405802,
                                    ["type"] = "t",
                                    ["x"] = 88.74997101323163,
                                    ["caption"] = " ",
                                }, -- [4]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 3"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L["Group"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Aerial Command Unit"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [12] = {
                    ["name"] = BabbleBoss["General Vezax"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-General Vezax"],} },
                    ["trash"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Trash-10-General Vezax"],} }, --optional
                    ["ratext"] = L["ra-General Vezax"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_vezax",
                            ["btnId"] = 1,
                            ["buttons"] = {
                            	{
                                    ["y"] = -124.5118932939792,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 266.0655305164788,
                                }, -- [1]
                                {
                                    ["y"] = -222.4289601548487,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 135.1161968843719,
                                }, -- [2]
                                {
                                    ["y"] = -170.2066768439925,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 249.0512812528752,
                                }, -- [3]
                                {
                                    ["y"] = -171.2944975033828,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 282.0838359263631,
                                }, -- [4]
                                {
                                    ["y"] = -133.2155471994864,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 287.9171133919461,
                                }, -- [5]
                                {
                                    ["y"] = -115.8081674129094,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 281.2971430270405,
                                }, -- [6]
                                {
                                    ["y"] = -114.7201938054485,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 300.8806319735552,
                                }, -- [7]
                                {
                                    ["y"] = -131.0397889204165,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 318.2879937662415,
                                }, -- [8]
                                {
                                    ["y"] = -140.8314794120018,
                                    ["type"] = "n",
                                    ["caption"] = " ",
                                    ["x"] = 323.7278348127099,
                                }, -- [9]
                                {
                                    ["y"] = -177.8223391481481,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 314.3295537494032,
                                }, -- [10]
                                {
                                    ["y"] = -162.5907806192583,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 221.8523099411115,
                                }, -- [11]
                                {
                                    ["y"] = -245.2762349695661,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 240.347708319876,
                                }, -- [12]
                                {
                                    ["y"] = -252.8919692492843,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 284.9544732777018,
                                }, -- [13]
                                {
                                    ["y"] = -251.8040586204407,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 325.20923584234,
                                }, -- [14]
                                {
                                    ["y"] = -273.5634048124239,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 171.0190830130573,
                                }, -- [15]
                                {
                                    ["y"] = -304.0264319007502,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 226.5054221004761,
                                }, -- [16]
                                {
                                    ["y"] = -314.9061139936871,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 293.9596058241444,
                                }, -- [17]
                                {
                                    ["y"] = -308.378362318375,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 359.2373744917341,
                                }, -- [18]
                                {
                                    ["y"] = -280.0911924755172,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 409.2839265143563,
                                }, -- [19]
                                {
                                    ["y"] = -237.6605186837385,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 440.8348102498543,
                                }, -- [20]
                                {
                                    ["y"] = -199.5817573156939,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 461.5063357824471,
                                }, -- [21]
                                {
                                    ["y"] = -169.1185862762424,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 130.764347439255,
                                }, -- [22]
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "n",
                                        ["caption"] = L_main["melee"],
                                        ["r"] = 235/255,
                                        ["g"] = 228/255,
                                        ["b"] = 45/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["General Vezax"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [13] = {
                    ["name"] = BabbleBoss["Yogg-Saron"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Yogg"],} },
                    ["ratext"] = L["ra-Yogg"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_yogg",
                            ["btnId"] = 8,
                            ["buttons"] = {
                            	{
                                    ["y"] = -490.1315569539429,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 251.7763572543825,
                                }, -- [1]
                                {
                                    ["y"] = -236.5132072418451,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 363.4868373355683,
                                }, -- [2]
                                {
                                    ["y"] = -391.4474324287706,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 251.5789367141943,
                                }, -- [3]
                                {
                                    ["y"] = -182.2369407070787,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 249.2105741593742,
                                }, -- [4]
                                {
                                    ["y"] = -239.4737923356618,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 107.8947121188354,
                                }, -- [5]
                                {
                                    ["y"] = -137.8288873088333,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 200.6579204865655,
                                }, -- [6]
                                {
                                    ["y"] = -144.7367889225128,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 372.368436290747,
                                }, -- [7]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 1"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L["Cloud"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L["Group"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Sara"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [2] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_yogg",
                            ["btnId"] = 6,
                            ["buttons"] = {
                            	{
									["y"] = -196.0525485265982,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 254.1447784315544,
                                }, -- [1]
                                {
                                    ["y"] = -384.5396089782269,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 392.8947401323812,
                                }, -- [2]
                                {
                                    ["y"] = -359.8683140463506,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 317.1053015444471,
                                }, -- [3]
                                {
                                    ["y"] = -317.4341729382279,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 412.43411714013,
                                }, -- [4]
                                {
                                    ["y"] = -344.078969803764,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 471.0526389790551,
                                }, -- [5]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 2"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L["Group"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Yogg-Saron"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                        [3] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_yogg",
                            ["btnId"] = 6,
                            ["buttons"] = {
                            	{
                                    ["y"] = -527.6314937898854,
                                    ["type"] = "y",
                                    ["caption"] = " ",
                                    ["x"] = 254.3420231046871,
                                }, -- [1]
                                {
                                    ["y"] = -189.1447055352705,
                                    ["type"] = "b",
                                    ["caption"] = " ",
                                    ["x"] = 249.2105741593742,
                                }, -- [2]
                                {
                                    ["y"] = -359.8682749647827,
                                    ["type"] = "f",
                                    ["caption"] = " ",
                                    ["x"] = 249.8026208313153,
                                }, -- [3]
                                {
                                    ["y"] = -427.9605987570993,
                                    ["type"] = "h",
                                    ["caption"] = " ",
                                    ["x"] = 250.0000218307196,
                                }, -- [4]
                                {
                                    ["y"] = -394.40778303318,
                                    ["type"] = "t",
                                    ["caption"] = " ",
                                    ["x"] = 249.6051612095593,
                                }, -- [5]
                            },
                            ["fontstrings"] = { --optional, put text on your map
                               [1] = {
                                    ["x"] = 217,
                                    ["y"] = -22,
                                    ["text"] = L["Phase 3"],
                                },
                            },
                            ["legend"] = { --optional, puts buttons to the legend
                                ["entries"] = {
                                    [1] = {
                                        ["type"] = "h",
                                        ["caption"] = L_main["healer"],
                                        ["r"] = 0,   --not optional
                                        ["g"] = 1,   --not optional
                                        ["b"] = 0,   --not optional
                                    },
                                    [2] = {
                                        ["type"] = "f",
                                        ["caption"] = L_main["ranged DPS"],
                                        ["r"] = 0,
                                        ["g"] = 0,
                                        ["b"] = 1,
                                    },
                                    [3] = {
                                        ["type"] = "t",
                                        ["caption"] = L_main["tank"],
                                        ["r"] = 1,
                                        ["g"] = 1,
                                        ["b"] = 1,
                                    },
                                    [4] = {
                                        ["type"] = "y",
                                        ["caption"] = L["Sanity Well"],
                                        ["r"] = 215/255,
                                        ["g"] = 121/255,
                                        ["b"] = 210/255,
                                    },
                                    [5] = {
                                        ["type"] = "b",
                                        ["caption"] = BabbleBoss["Yogg-Saron"],
                                        ["r"] = 1,
                                        ["g"] = 0,
                                        ["b"] = 0,
                                    },
                                },
                            },
                        },
                    },
                },
                [14] = {
                    ["name"] = BabbleBoss["Algalon the Observer"],
                    ["tactictext"] = { [1] = {["name"] = "BossTactics", ["data"]=L["Tactic-25-Algalon the Observer"],} },
                    ["ratext"] = L["ra-Algalon the Observer"],
                    ["imgdata"] = {
                        [1] = {
                            ["source"] = "Interface\\Addons\\BT_Ulduar\\Img\\map_algalon",
                            ["btnId"] = 1,
                            ["buttons"] = {},
                        },
                    },
                },
            },
            --the next mode could start here
		},
    },
}

local function ILvlRequest(Msg,distribution,target)

	local regex_ilvl = "{UlduarIlvlRes:(.*)}"

	if(Msg == "{UlduarIlvl}")then
		if(BT_main:IsRaidLeader()) then
			if(not BT_main.QueryResultFrame or not BT_main.QueryResultFrame:IsShown())then
			    BT_main:ShowQueryResultFrame()
                BT_main:ClearQueryResults(L["Average Item Level"]..": 0")
            end
		end
		local result = BT_Ulduar:VehicleInfo(true)
		BT_main:BT_SendDataMessage("{UlduarIlvlRes:"..tostring(result).."}")
		return true
	end

	if(BT_main:IsRaidLeader())then
	    for ilvl in string.gmatch(Msg,regex_ilvl) do
	    	local resultStr = L["Average Item Level"]..": "..ilvl
	    	if(tonumber(ilvl) < 213)then
            	BT_main:InsertQueryResult(target,resultStr,false)
            else
            	BT_main:InsertQueryResult(target,resultStr,true)
            end
        end
    end
end

function BT_Ulduar:OnInitialize()
 	--initialize database
    self.db = LibStub("AceDB-3.0"):New("BT_UlduarDB", defaults, "Default") --change the name here
    self:CheckUpdate()
    BT_main:RegisterForCommunication(ILvlRequest)

    table.insert(BT_main.modules,self.db.profile)

    self.vehicleInfo = {
		["FlameLeviathan"] = {
			"HeadSlot", "NeckSlot", "ShoulderSlot", "BackSlot", "ChestSlot",
			"WristSlot", "HandsSlot", "WaistSlot", "LegsSlot", "FeetSlot", "Finger0Slot", "Finger1Slot", "Trinket0Slot", "Trinket1Slot",
			"MainHandSlot",
		}
	}
end;

------------------------------------------------
--this function is needed by the main program! dont touch it!
------------------------------------------------
function BT_Ulduar:GetDefaults()
	return defaults;
end;

-----------------------------------------------
--handels updates in data
--refer to the tutorial how to get version changes!
-----------------------------------------------

function BT_Ulduar:CheckUpdate()

	minor, second = strsplit(".",BT_main.version)
	if(tonumber(minor) == 2)then
        if(tonumber(second) < 11)then
            BT_main:ShowInfoMessage(format(L["new main version"],"2.11"))
            return
        end
    else
        if(tonumber(minor) <= 2)then
            BT_main:ShowInfoMessage(format(L["new main version"],"2.11"))
            return
        end
    end
	--the versions stored by the client musst be one more
	--because otherwise it woudnt been saved in the savedVariables
	if(not self.db.profile.initial)then
		if(defaults.profile.version+1 > self.db.profile.version)then
			--build up update data structure
			self.updateInfo = {}
			if(defaults.profile.version >= 2 and self.db.profile.version <= 2)then -- <=2 because it was incremmented, this means v1 in profile
				if(not self:CompareBosses(self.db.profile.bosses.mode10[1].imgdata,defaults.profile.bosses.mode10[1].imgdata))then
				    self.updateInfo[1] = {}
                    self.updateInfo[1].mode10 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode25[1].imgdata,defaults.profile.bosses.mode25[1].imgdata))then
				    if(not self.updateInfo[1]) then self.updateInfo[1] = {} end
                    self.updateInfo[1].mode25 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode10[3].imgdata,defaults.profile.bosses.mode10[3].imgdata))then
				    self.updateInfo[3] = {}
                    self.updateInfo[3].mode10 = true;
                end
                if(not self:CompareBosses(self.db.profile.bosses.mode25[3].imgdata,defaults.profile.bosses.mode25[3].imgdata))then
				    if(not self.updateInfo[3]) then self.updateInfo[3] = {} end
                    self.updateInfo[3].mode25 = true;
                end

			end
			if(defaults.profile.version >= 3 and self.db.profile.version <= 3)then
				if(not self:CompareBosses(self.db.profile.bosses.mode10[4].imgdata,defaults.profile.bosses.mode10[4].imgdata))then
				    self.updateInfo[4] = {}
                    self.updateInfo[4].mode10 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode25[4].imgdata,defaults.profile.bosses.mode25[4].imgdata))then
				    if(not self.updateInfo[4]) then self.updateInfo[4] = {} end
                    self.updateInfo[4].mode25 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode10[6].imgdata,defaults.profile.bosses.mode10[6].imgdata))then
				    self.updateInfo[6] = {}
                    self.updateInfo[6].mode10 = true;
                end
                if(not self:CompareBosses(self.db.profile.bosses.mode25[6].imgdata,defaults.profile.bosses.mode25[6].imgdata))then
				    if(not self.updateInfo[6]) then self.updateInfo[6] = {} end
                    self.updateInfo[6].mode25 = true;
                end

			end
			if(defaults.profile.version >= 4 and self.db.profile.version <= 4)then
				if(not self:CompareBosses(self.db.profile.bosses.mode10[5].imgdata,defaults.profile.bosses.mode10[5].imgdata))then
				    self.updateInfo[5] = {}
                    self.updateInfo[5].mode10 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode25[5].imgdata,defaults.profile.bosses.mode25[5].imgdata))then
				    if(not self.updateInfo[5]) then self.updateInfo[5] = {} end
                    self.updateInfo[5].mode25 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode10[7].imgdata,defaults.profile.bosses.mode10[7].imgdata))then
				    self.updateInfo[7] = {}
                    self.updateInfo[7].mode10 = true;
                end
                if(not self:CompareBosses(self.db.profile.bosses.mode25[7].imgdata,defaults.profile.bosses.mode25[7].imgdata))then
				    if(not self.updateInfo[7]) then self.updateInfo[7] = {} end
                    self.updateInfo[7].mode25 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode10[8].imgdata,defaults.profile.bosses.mode10[8].imgdata))then
				    self.updateInfo[8] = {}
                    self.updateInfo[8].mode10 = true;
                end
                if(not self:CompareBosses(self.db.profile.bosses.mode25[8].imgdata,defaults.profile.bosses.mode25[8].imgdata))then
				    if(not self.updateInfo[8]) then self.updateInfo[8] = {} end
                    self.updateInfo[8].mode25 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode10[9].imgdata,defaults.profile.bosses.mode10[9].imgdata))then
				    self.updateInfo[9] = {}
                    self.updateInfo[9].mode10 = true;
                end
                if(not self:CompareBosses(self.db.profile.bosses.mode25[9].imgdata,defaults.profile.bosses.mode25[9].imgdata))then
				    if(not self.updateInfo[9]) then self.updateInfo[9] = {} end
                    self.updateInfo[9].mode25 = true;
                end

			end
			if(defaults.profile.version >= 5 and self.db.profile.version <= 5)then
				if(not self:CompareBosses(self.db.profile.bosses.mode10[2].imgdata,defaults.profile.bosses.mode10[2].imgdata))then
				    self.updateInfo[2] = {}
                    self.updateInfo[2].mode10 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode25[2].imgdata,defaults.profile.bosses.mode25[2].imgdata))then
				    if(not self.updateInfo[2]) then self.updateInfo[2] = {} end
                    self.updateInfo[2].mode25 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode10[10].imgdata,defaults.profile.bosses.mode10[10].imgdata))then
				    self.updateInfo[10] = {}
                    self.updateInfo[10].mode10 = true;
                end
                if(not self:CompareBosses(self.db.profile.bosses.mode25[10].imgdata,defaults.profile.bosses.mode25[10].imgdata))then
				    if(not self.updateInfo[10]) then self.updateInfo[10] = {} end
                    self.updateInfo[10].mode25 = true;
                end

			end
			if(defaults.profile.version >= 6 and self.db.profile.version <= 6)then
				if(not self:CompareBosses(self.db.profile.bosses.mode10[11].imgdata,defaults.profile.bosses.mode10[11].imgdata))then
				    self.updateInfo[11] = {}
                    self.updateInfo[11].mode10 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode25[11].imgdata,defaults.profile.bosses.mode25[11].imgdata))then
				    if(not self.updateInfo[11]) then self.updateInfo[11] = {} end
                    self.updateInfo[11].mode25 = true;
                end

			end
			if(defaults.profile.version >= 7 and self.db.profile.version <= 7)then
				if(not self:CompareBosses(self.db.profile.bosses.mode10[12].imgdata,defaults.profile.bosses.mode10[12].imgdata))then
				    self.updateInfo[12] = {}
                    self.updateInfo[12].mode10 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode25[12].imgdata,defaults.profile.bosses.mode25[12].imgdata))then
				    if(not self.updateInfo[12]) then self.updateInfo[12] = {} end
                    self.updateInfo[12].mode25 = true;
                end

			end
			if(defaults.profile.version >= 8 and self.db.profile.version <= 8)then
				if(not self:CompareBosses(self.db.profile.bosses.mode10[13].imgdata,defaults.profile.bosses.mode10[13].imgdata))then
				    self.updateInfo[13] = {}
                    self.updateInfo[13].mode10 = true;
                end

                if(not self:CompareBosses(self.db.profile.bosses.mode25[13].imgdata,defaults.profile.bosses.mode25[13].imgdata))then
				    if(not self.updateInfo[13]) then self.updateInfo[13] = {} end
                    self.updateInfo[13].mode25 = true;
                end

			end
			if(defaults.profile.version >= 9 and self.db.profile.version <= 9)then
				if(not self:CompareBosses(self.db.profile.bosses.mode10[14].imgdata,defaults.profile.bosses.mode10[14].imgdata))then
				    self.updateInfo[14] = {}
                    self.updateInfo[14].mode10 = true;
                end
			end
			local found = false
			for i,v in pairs(self.updateInfo)do
				if(v and (v.mode10 or v.mode25)) then
					found = true
					break
				end
			end
			if(found)then
				BT_main:ShowUpdateMessageFrame(format(L["update msg"],defaults.profile.version),
															    function() self.updateAll = true;
																		   self:PerformUpdate(1,true);
																		   end,
																function() self.updateAll = false;
																		   self:PerformUpdate(1,true);
																		   end)
			else
				self.db.profile.version = defaults.profile.version+1
			end
		end
	else
		self.db.profile.version = defaults.profile.version+1
	end
	self.db.profile.initial = false
end;

function BT_Ulduar:PerformUpdate(start,mode) --next index, true=mode10
	local v = nil
	while(start <= 14)do
		if(self.updateInfo[start])then
			if(mode)then
				if(self.updateInfo[start].mode10)then
				    v = self.updateInfo[start]
                    break
                else
                	mode = false
                end
			else
				if(self.updateInfo[start].mode25)then
				    v = self.updateInfo[start]
                    break
                else
                	start=start+1
                	mode = true
                end
			end
		else
			start=start+1
		end
	end
	if(not v)then
		self:Print(L["Update finished."])
   		self.db.profile.version = defaults.profile.version+1
   		return
	end
	if(v.mode10 and mode)then
        if(not self:CompareBosses(self.db.profile.bosses.mode10[start].imgdata,defaults.profile.bosses.mode10[start].imgdata))then
            local yesfun = function() BT_Ulduar:ResetButtonsForBoss(self.db.profile.bosses.mode10[start].imgdata, defaults.profile.bosses.mode10[start].imgdata);
                                      self:PerformUpdate(start, false) end
            if(self.updateAll)then
                yesfun()
            else
                BT_main:ShowQuestionFrame(format(L["Reset Boss"],self.db.profile.bosses.mode10[start].name, 10),
                yesfun,
                function() BT_Ulduar:CleanUpButtons(self.db.profile.bosses.mode10[start].imgdata, defaults.profile.bosses.mode10[start].imgdata);
                	       self:PerformUpdate(start, false) end)
            end
        else
        	self:PerformUpdate(start, false)
        end
    elseif(v.mode25 and not mode)then
    	if(not self:CompareBosses(self.db.profile.bosses.mode25[start].imgdata,defaults.profile.bosses.mode25[start].imgdata))then
            local yesfun = function() BT_Ulduar:ResetButtonsForBoss(self.db.profile.bosses.mode25[start].imgdata, defaults.profile.bosses.mode25[start].imgdata);
                                      self:PerformUpdate(start+1, true) end
            if(self.updateAll)then
                yesfun()
            else
                BT_main:ShowQuestionFrame(format(L["Reset Boss"],self.db.profile.bosses.mode25[start].name, 25),
                yesfun,
                function() BT_Ulduar:CleanUpButtons(self.db.profile.bosses.mode25[start].imgdata, defaults.profile.bosses.mode25[start].imgdata);
                           self:PerformUpdate(start+1, true) end)
            end
        else
        	self:PerformUpdate(start+1, true)
    	end
    end

end;

function BT_Ulduar:CleanUpButtons(b, bDef)

	for i,v in ipairs(b)do
		local img2 = bDef[i]
		local counter = 0
		local UBtnList = {}
		for ind, val in ipairs(v.buttons) do
			local tmpBtn = {}
			counter = counter + 1
			if(img2.buttons[ind])then
			    if(val.x == img2.buttons[ind].x and val.type == img2.buttons[ind].type
                    and val.y == img2.buttons[ind].y and val.caption == img2.buttons[ind].caption)then
                    --ende der Liste
                    break;
                else
                	--user button kopieren
                	tmpBtn.x = val.x
			        tmpBtn.y = val.y
                    tmpBtn.caption = val.caption
                    tmpBtn.type = val.type
                    tinsert(UBtnList,tmpBtn)
                end
            else
            	tmpBtn.x = val.x
			    tmpBtn.y = val.y
                tmpBtn.caption = val.caption
                tmpBtn.type = val.type
                tinsert(UBtnList,tmpBtn)
			end
		end
		v.buttons = {}
		for i=1, img2.btnId-1, 1 do
			local tmpBtn = {}
			tmpBtn.deleted = true
			tinsert(v.buttons,tmpBtn)
		end

		for ind,val in ipairs(UBtnList)do
			tinsert(v.buttons,val)
		end
		v.btnId = img2.btnId+counter
	end

end

function BT_Ulduar:ResetButtonsForBoss(b, bDef)

	for i,v in ipairs(b)do
		local img2 = bDef[i]
		v.btnId = img2.btnId
		v.buttons = {}
		for ind, val in ipairs(img2.buttons) do
			local tmpBtn = {}
			tmpBtn.x = val.x
			tmpBtn.y = val.y
			tmpBtn.caption = val.caption
			tmpBtn.type = val.type
			tinsert(v.buttons,tmpBtn)
		end
	end

end

function BT_Ulduar:CompareBosses(b1, b2)

	for i,v in ipairs(b1)do
		local img2 = b2[i]
		if(v.btnId ~= img2.btnId)then
			return false
		end
		for ind, val in ipairs(v.buttons) do
			if(val.x ~= img2.buttons[ind].x or val.type ~= img2.buttons[ind].type
			    or val.y ~= img2.buttons[ind].y or val.caption ~= img2.buttons[ind].caption)then
			    return false
			end
		end
	end
	return true
end;
----------------------------------------------------------
--place here the action button functions if you need them
----------------------------------------------------------

function BT_Ulduar:VehicleInfo(noPrint)
	local sum = 0
	local result = 0
	for i,v in pairs(self.vehicleInfo)do
		if(strlower(i) == "flameleviathan")then
			if(not noPrint)then
				BossTactics:Print(format(L["vehicle stats"],i))
				DEFAULT_CHAT_FRAME:AddMessage("Item Quality/Item Level:",1,0,0)
			end
			for ind, val in ipairs(v)do
				local slotId = GetInventorySlotInfo(val)
				local slotLink = GetInventoryItemLink("player", slotId)
				if slotLink ~= nil then
					local _,_,rarity,itemLvl = GetItemInfo(slotLink)
					local _, _, _, hex = GetItemQualityColor(rarity);
					if(not noPrint)then
						DEFAULT_CHAT_FRAME:AddMessage(L[val]..": "..hex..getglobal("ITEM_QUALITY" .. rarity .. "_DESC").."|r "..tostring(itemLvl),1,1,1)
					end
					if(rarity < 4)then
						sum = sum+(itemLvl-(4-rarity)*13)
					else
						sum = sum+itemLvl
					end
				else
					if(not noPrint)then
						DEFAULT_CHAT_FRAME:AddMessage(L[val]..": "..L["empty"].." - 0",1,1,1)
					end
				end
			end
			result = math.floor(sum/#v)
			if(not noPrint)then
			    DEFAULT_CHAT_FRAME:AddMessage(L["Average Item Level"]..": "..tostring(result),0,1,0)
                DEFAULT_CHAT_FRAME:AddMessage(L["Health Increasing"]..": "..tostring(result-170).."%",0,1,0)
			end
			break
		end
	end
	return result
end

function BT_Ulduar:ShowLeviathanTasks()

	local theFrame = BT_main.MainWindow
    local taskInfo = {}
    taskInfo.Task = {}
    taskInfo.showInputChange = false
    taskInfo.Post = function (arg1, arg2)
        if(type(arg1) == "table") then arg1 = arg2 end
        local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        local tbl = {}
        local intro = ""
        local extro = ""
        local tbl = {}
        if(arg1 == L["Demolisher"])then
           tbl = boss.taskDemo
           intro = L["intro Demolisher"]
           extro = format(L["extro levi task"], "demolisher")
        elseif(arg1 == L["Siege Engine"])then
           tbl = boss.taskSiege
           intro = L["intro Siege"]
           extro = format(L["extro levi task"], "siege")
        elseif(arg1 == L["Chopper"])then
           tbl = boss.taskChopper
           intro = L["intro Chopper"]
           extro = format(L["extro levi task"], "chopper")
        end
        ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS", intro, "RAID")
        ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS", "-----------------------------------------", "RAID")
        for i,v in ipairs(tbl)do
            local str = v.player
            if(v.player1)then
                str = str.." - "..v.player1
            end
            if(v.player2)then
                str = str.." - "..v.player2
            end
            ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS",str, "RAID")
        end
        ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS", extro, "RAID")
        ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS", " ", "RAID")
    end
    taskInfo.PostAll = function()
        local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        if(boss.taskDemo and #boss.taskDemo>0)then
            taskInfo:Post(L["Demolisher"])
        end
        if(boss.taskSiege and #boss.taskSiege>0)then
            taskInfo:Post(L["Siege Engine"])
        end
        if(boss.taskChopper and #boss.taskChopper>0)then
            taskInfo:Post(L["Chopper"])
        end
    end
    taskInfo.HandleWhisper = function(target, msg, arg3)
        if(type(target) == "table") then target = msg; msg = arg3 end
        msg = strlower(msg)
        local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        local tbl = {}
        local found = false
        local plfound = false
        if(msg == "demolisher")then
        	for i,v in ipairs(boss.taskDemo)do
                if(v.player == target)then
                	plfound = true
                    ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS",L["driver demolisher"], "WHISPER", nil, target)
                    break
                elseif(v.player1 == target)then
                	plfound = true
                    ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS",format(L["shooter demolisher"],v.player), "WHISPER", nil, target)
                    break
                elseif(v.player2 == target)then
                	plfound = true
                    ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS",format(L["cannon demolisher"], v.player), "WHISPER", nil, target)
                    break
                end
        	end
        	found = true
        elseif(msg == "siege")then
             for i,v in ipairs(boss.taskSiege)do
                if(v.player == target)then
                	plfound = true
                    ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS",L["driver siege"], "WHISPER", nil, target)
                    break
                elseif(v.player1 == target)then
                	plfound = true
                    ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS",format(L["shooter siege"],v.player), "WHISPER", nil, target)
                    break
                end
        	end
            found = true
        elseif(msg == "chopper")then
             for i,v in ipairs(boss.taskChopper)do
                if(v.player == target)then
                	plfound = true
                    ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS",L["driver chopper"], "WHISPER", nil, target)
                    break
                end
        	end
             found = true
        end
        if(not found)then return end
        if(not plfound)then
            ChatThrottleLib:SendChatMessage("NORMAL", "BOSSTACTICS",L_main["no task"], "WHISPER", nil, target)
        end

    end
    taskInfo.CursorChange = function(arg1, arg2)

    end
    taskInfo.Select = function(arg1, arg2)

    end
    taskInfo.Save = function(arg1, arg2, arg3)

    end
    taskInfo.Task.Label = L["Vehicle:"]
    taskInfo.Task.Init = function()
    	local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        theFrame.TaskManagerFrame:Clean()
        local str = ""
        theFrame.TaskManagerFrame.TaskDropdown.selected = L["Demolisher"]
        theFrame.TaskManagerFrame.Player2Dropdown:Hide()
        theFrame.TaskManagerFrame.Player2Label:Hide()
        theFrame.TaskManagerFrame.Player3Dropdown:Hide()
        theFrame.TaskManagerFrame.Player3Label:Hide()
        UIDropDownMenu_SetText(theFrame.TaskManagerFrame.TaskDropdown, L["Demolisher"])
        if (not boss.taskDemo)then
               boss.taskDemo = {}
        end
        if (not boss.taskSiege)then
               boss.taskSiege = {}
        end
        if (not boss.taskChopper)then
               boss.taskChopper = {}
        end
		theFrame.TaskManagerFrame.ChangeInput:SetText("")
        for i,v in ipairs(boss.taskDemo)do
            local colChar = BT_main:FindColor(v.player)
            str = str..colChar.." - "..BT_main:FindColor(v.player1).." - "..BT_main:FindColor(v.player2).."\n"
            theFrame.TaskManagerFrame:AddPlayer(colChar)
        end
        theFrame.TaskManagerFrame.TaskInput:SetText(strtrim(str))
        theFrame.TaskManagerFrame.TaskInput.tmpOld = strtrim(str)
    end
    taskInfo.Task.Click = function(arg1)
    	local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        theFrame.TaskManagerFrame.TaskDropdown.selected = arg1
        UIDropDownMenu_SetText(theFrame.TaskManagerFrame.TaskDropdown, arg1)

		local tbl = {}
        if(theFrame.TaskManagerFrame.TaskDropdown.selected == L["Demolisher"])then
           tbl = boss.taskDemo
        elseif(theFrame.TaskManagerFrame.TaskDropdown.selected == L["Siege Engine"])then
           tbl = boss.taskSiege
        elseif(theFrame.TaskManagerFrame.TaskDropdown.selected == L["Chopper"])then
           tbl = boss.taskChopper
        end

        theFrame.TaskManagerFrame:Clean()
        local str = ""
        for i,v in ipairs(tbl)do
            local colChar = BT_main:FindColor(v.player)
            str = str..colChar
            if(v.player1)then
            	str = str.." - "..BT_main:FindColor(v.player1)
            end
            if(v.player2)then
            	str = str.." - "..BT_main:FindColor(v.player2)
            end
            str = str.."\n"
            theFrame.TaskManagerFrame:AddPlayer(colChar)
        end
        theFrame.TaskManagerFrame.TaskInput:SetText(strtrim(str))
        theFrame.TaskManagerFrame.TaskInput.tmpOld = strtrim(str)
        theFrame.TaskManagerFrame.Player2Dropdown:Hide()
        theFrame.TaskManagerFrame.Player2Label:Hide()
        theFrame.TaskManagerFrame.Player3Dropdown:Hide()
        theFrame.TaskManagerFrame.Player3Label:Hide()
        taskInfo.Player1:Init()
    end
    taskInfo.Task.Values = function ()
       return {{L["Demolisher"],L["Demolisher"]}, {L["Siege Engine"],L["Siege Engine"]}, {L["Chopper"],L["Chopper"]}}
    end

    taskInfo.Player1 = {}
    taskInfo.Player1.Label = L["Driver:"]
    taskInfo.Player1.Init = function()
    	local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        local filter = {}
        for i,v in ipairs(boss.taskDemo)do
        	tinsert(filter,v.player)
        	tinsert(filter,v.player1)
        	tinsert(filter,v.player2)
        end
        for i,v in ipairs(boss.taskSiege)do
        	tinsert(filter,v.player)
        	tinsert(filter,v.player1)
        end
        for i,v in ipairs(boss.taskChopper)do
        	tinsert(filter,v.player)
        end
        UIDropDownMenu_SetText(theFrame.TaskManagerFrame.PlayerDropdown, "")
        local anzMembers = GetNumRaidMembers()
        for i=1, anzMembers, 1 do
            local name, _, subgr, _, _,fileName = GetRaidRosterInfo(i)
            local found = false
            for ind,val in ipairs(filter)do
                if(name == val and subgr <= 5)then
                  	found = true
                  	break
                end
            end
            if(not found)then
            	UIDropDownMenu_SetText(theFrame.TaskManagerFrame.PlayerDropdown, name)
            	break
            end
        end
    end
    taskInfo.Player1.Delete = function (arg1, arg2)
        local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        local str = ""
        if(type(arg1) == "table") then arg1 = arg2 end
        local tbl = {}
        if(theFrame.TaskManagerFrame.TaskDropdown.selected == L["Demolisher"])then
           tbl = boss.taskDemo
        elseif(theFrame.TaskManagerFrame.TaskDropdown.selected == L["Siege Engine"])then
           tbl = boss.taskSiege
        elseif(theFrame.TaskManagerFrame.TaskDropdown.selected == L["Chopper"])then
           tbl = boss.taskChopper
        end
        for i,v in ipairs(tbl)do
            if(v.player == strsub(arg1,11,-3))then
                tremove(tbl,i)
                break
            end
        end
        for i,v in ipairs(tbl)do
            local colChar = BT_main:FindColor(v.player)
            str = str..colChar
            if(v.player1)then
            	str = str.." - "..BT_main:FindColor(v.player1)
            end
            if(v.player2)then
            	str = str.." - "..BT_main:FindColor(v.player2)
            end
            str = str.."\n"
            theFrame.TaskManagerFrame:AddPlayer(colChar)
        end
        theFrame.TaskManagerFrame.TaskInput:SetText(strtrim(str))
        theFrame.TaskManagerFrame.TaskInput.tmpOld = strtrim(str)
    end
    taskInfo.Player1.Click = function(arg1)
        local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        UIDropDownMenu_SetText(theFrame.TaskManagerFrame.PlayerDropdown, arg1)
        theFrame.TaskManagerFrame.PlayerDropdown.selected = arg1
        if(theFrame.TaskManagerFrame.TaskDropdown.selected ~= L["Chopper"])then
            theFrame.TaskManagerFrame.Player2Dropdown:Show()
            theFrame.TaskManagerFrame.Player2Label:Show()
            taskInfo.Player2:Init()
        else
            theFrame.TaskManagerFrame.AddPlayer(BT_main:FindColor(arg1))
            local found = false
            for i,v in ipairs(boss.taskChopper)do
                if(v.player == arg1)then
                    found = true
                end
            end
            if(not found)then
            	tinsert(boss.taskChopper, {player = arg1})
            end
            local str = ""
            for i,v in ipairs(boss.taskChopper)do
                str = str..BT_main:FindColor(v.player).."\n"
            end
            theFrame.TaskManagerFrame.TaskInput:SetText(strtrim(str))
            theFrame.TaskManagerFrame.TaskInput.tmpOld = strtrim(str)
        end
    end
    taskInfo.Player1.Values = function ()
    	local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        local tbl = {}
        local anzMembers = GetNumRaidMembers()
        local filter = {}
        for i,v in ipairs(boss.taskDemo)do
        	tinsert(filter,v.player)
        	tinsert(filter,v.player1)
        	tinsert(filter,v.player2)
        end
        for i,v in ipairs(boss.taskSiege)do
        	tinsert(filter,v.player)
        	tinsert(filter,v.player1)
        end
        for i,v in ipairs(boss.taskChopper)do
        	tinsert(filter,v.player)
        end

        for i=1, anzMembers, 1 do
            local name, _, subgr, _, _,fileName = GetRaidRosterInfo(i)
            local found = false
            for ind,val in ipairs(filter)do
                if(name == val or subgr > 5)then
                	found = true
                	break
                end
            end
            if(not found)then
            	tinsert(tbl,{name,name})
            end
        end
        return tbl
    end

    taskInfo.Player2 = {}
    taskInfo.Player2.Label = L["Shooter:"]
    taskInfo.Player2.Init = function()
        local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        local filter = {}
        for i,v in ipairs(boss.taskDemo)do
        	tinsert(filter,v.player)
        	tinsert(filter,v.player1)
        	tinsert(filter,v.player2)
        end
        for i,v in ipairs(boss.taskSiege)do
        	tinsert(filter,v.player)
        	tinsert(filter,v.player1)
        end
        for i,v in ipairs(boss.taskChopper)do
        	tinsert(filter,v.player)
        end
        UIDropDownMenu_SetText(theFrame.TaskManagerFrame.Player2Dropdown, "")
        local anzMembers = GetNumRaidMembers()
        for i=1, anzMembers, 1 do
            local name, _, subgr, _, _,fileName = GetRaidRosterInfo(i)
            local found = false
            for ind,val in ipairs(filter)do
                if(name == val and subgr <= 5)then
                  	found = true
                  	break
                end
            end
            if(not found)then
            	UIDropDownMenu_SetText(theFrame.TaskManagerFrame.Player2Dropdown, name)
            	break
            end
        end
    end
    taskInfo.Player2.Click = function(arg1)
        local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        theFrame.TaskManagerFrame.Player2Dropdown.selected = arg1
        if(theFrame.TaskManagerFrame.TaskDropdown.selected == L["Siege Engine"])then
            local found = false
            for i,v in ipairs(boss.taskSiege)do
                if(v.player == theFrame.TaskManagerFrame.PlayerDropdown.selected)then
                    found = true
                    break
                end
            end
            if(not found)then
                theFrame.TaskManagerFrame.AddPlayer(BT_main:FindColor(theFrame.TaskManagerFrame.PlayerDropdown.selected))
                tinsert(boss.taskSiege, {player = theFrame.TaskManagerFrame.PlayerDropdown.selected, player1 = arg1})
            end
            local str = ""
            for i,v in ipairs(boss.taskSiege)do
                str = str..BT_main:FindColor(v.player).." - "..BT_main:FindColor(v.player1).."\n"
            end
            theFrame.TaskManagerFrame.TaskInput:SetText(strtrim(str))
            theFrame.TaskManagerFrame.TaskInput.tmpOld = strtrim(str)
        else
        	theFrame.TaskManagerFrame.Player3Dropdown:Show()
            theFrame.TaskManagerFrame.Player3Label:Show()
            taskInfo.Player3:Init()
        end
        UIDropDownMenu_SetText(theFrame.TaskManagerFrame.Player2Dropdown, arg1)
    end
    taskInfo.Player2.Values = function ()
        local vals = taskInfo.Player1:Values()
        tinsert(vals,1,{L["none"],L["none"]})
        return vals
    end

    taskInfo.Player3 = {}
    taskInfo.Player3.Label = L["Cannon:"]
    taskInfo.Player3.Init = function()
        local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        local filter = {}
        for i,v in ipairs(boss.taskDemo)do
        	tinsert(filter,v.player)
        	tinsert(filter,v.player1)
        	tinsert(filter,v.player2)
        end
        for i,v in ipairs(boss.taskSiege)do
        	tinsert(filter,v.player)
        	tinsert(filter,v.player1)
        end
        for i,v in ipairs(boss.taskChopper)do
        	tinsert(filter,v.player)
        end
        UIDropDownMenu_SetText(theFrame.TaskManagerFrame.Player3Dropdown, "")
        local anzMembers = GetNumRaidMembers()
        for i=1, anzMembers, 1 do
            local name, _, subgr, _, _,fileName = GetRaidRosterInfo(i)
            local found = false
            for ind,val in ipairs(filter)do
                if(name == val and subgr <= 5)then
                  	found = true
                  	break
                end
            end
            if(not found)then
            	UIDropDownMenu_SetText(theFrame.TaskManagerFrame.Player3Dropdown, name)
            	break
            end
        end
    end
    taskInfo.Player3.Click = function(arg1)
         local boss = self.db.profile.bosses[BT_main.currInstanceMode][1]
        if(theFrame.TaskManagerFrame.TaskDropdown.selected == L["Demolisher"])then
            local found = false
            for i,v in ipairs(boss.taskDemo)do
                if(v.player == theFrame.TaskManagerFrame.PlayerDropdown.selected)then
                    found = true
                    break
                end
            end
            if(not found)then
                theFrame.TaskManagerFrame.AddPlayer(BT_main:FindColor(theFrame.TaskManagerFrame.PlayerDropdown.selected))
                tinsert(boss.taskDemo, {player = theFrame.TaskManagerFrame.PlayerDropdown.selected, player1 = theFrame.TaskManagerFrame.Player2Dropdown.selected, player2 = arg1})
            end
            local str = ""
            for i,v in ipairs(boss.taskDemo)do
                str = str..BT_main:FindColor(v.player).." - "..BT_main:FindColor(v.player1).." - "..BT_main:FindColor(v.player2).."\n"
            end
            theFrame.TaskManagerFrame.TaskInput:SetText(strtrim(str))
            theFrame.TaskManagerFrame.TaskInput.tmpOld = strtrim(str)
        end
        UIDropDownMenu_SetText(theFrame.TaskManagerFrame.Player3Dropdown, arg1)
    end
    taskInfo.Player3.Values = function ()
        local vals = taskInfo.Player1:Values()
        tinsert(vals,1,{L["none"],L["none"]})
        return vals
    end

    BT_main:ShowTaskManager(taskInfo)

end;

----------------------------------------------------------------
--dont touch this functions!
----------------------------------------------------------------

function BT_Ulduar:ResetData()
	self.db:ResetDB()
	self.db.profile.version = defaults.profile.version+1
	self:Print(L["Module resetted"])
end;

function BT_Ulduar:OnEnable()
    -- Called when the addon is enabled
end

function BT_Ulduar:OnDisable()
    -- Called when the addon is disabled
end